	.text
	.file	"kem.c"
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_keypair
.LCPI0_0:
	.long	1073741823              # 0x3fffffff
.LCPI0_1:
	.long	3                       # 0x3
.LCPI0_3:
	.long	4294967294              # 0xfffffffe
.LCPI0_4:
	.long	4294967292              # 0xfffffffc
.LCPI0_5:
	.long	1                       # 0x1
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI0_2:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
.LCPI0_7:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI0_6:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.text
	.globl	crypto_kem_keypair
	.p2align	4, 0x90
	.type	crypto_kem_keypair,@function
crypto_kem_keypair:                     # @crypto_kem_keypair
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$8616, %rsp             # imm = 0x21A8
	.cfi_def_cfa_offset 8672
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rsi, %rbx
	movq	%rdi, %r14
	vbroadcastss	.LCPI0_0(%rip), %ymm0 # ymm0 = [1073741823,1073741823,1073741823,1073741823,1073741823,1073741823,1073741823,1073741823]
	vmovups	%ymm0, 2656(%rsp)       # 32-byte Spill
	movq	%rsp, %r15
	vpbroadcastd	.LCPI0_1(%rip), %ymm0 # ymm0 = [3,3,3,3,3,3,3,3]
	vmovdqu	%ymm0, 2624(%rsp)       # 32-byte Spill
	movl	$1073741823, %ebp       # imm = 0x3FFFFFFF
	leaq	4016(%rsp), %r12
	leaq	2704(%rsp), %r13
	.p2align	4, 0x90
.LBB0_1:                                # =>This Loop Header: Depth=1
                                        #     Child Loop BB0_2 Depth 2
	movl	$2612, %esi             # imm = 0xA34
	movq	%r15, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_653xint32_little@PLT
	movl	$24, %eax
	vmovdqa	.LCPI0_2(%rip), %xmm5   # xmm5 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	vmovdqa	%xmm5, %xmm8
	vmovdqu	2656(%rsp), %ymm6       # 32-byte Reload
	vmovdqu	2624(%rsp), %ymm7       # 32-byte Reload
	vpcmpeqd	%xmm5, %xmm5, %xmm5
	.p2align	4, 0x90
.LBB0_2:                                #   Parent Loop BB0_1 Depth=1
                                        # =>  This Inner Loop Header: Depth=2
	vpand	-96(%rsp,%rax,4), %ymm6, %ymm0
	vpand	-64(%rsp,%rax,4), %ymm6, %ymm1
	vpand	-32(%rsp,%rax,4), %ymm6, %ymm2
	vpand	(%rsp,%rax,4), %ymm6, %ymm3
	vpmulld	%ymm7, %ymm0, %ymm0
	vpmulld	%ymm7, %ymm1, %ymm1
	vpmulld	%ymm7, %ymm2, %ymm2
	vpmulld	%ymm7, %ymm3, %ymm3
	vpsrld	$30, %ymm0, %ymm0
	vpsrld	$30, %ymm1, %ymm1
	vpsrld	$30, %ymm2, %ymm2
	vpsrld	$30, %ymm3, %ymm3
	vextracti128	$1, %ymm0, %xmm4
	vpackusdw	%xmm4, %xmm0, %xmm0
	vextracti128	$1, %ymm1, %xmm4
	vpackusdw	%xmm4, %xmm1, %xmm1
	vextracti128	$1, %ymm2, %xmm4
	vpackusdw	%xmm4, %xmm2, %xmm2
	vextracti128	$1, %ymm3, %xmm4
	vpackusdw	%xmm4, %xmm3, %xmm3
	vpaddb	%xmm5, %xmm0, %xmm0
	vpshufb	%xmm8, %xmm0, %xmm0
	vpaddb	%xmm5, %xmm1, %xmm1
	vpshufb	%xmm8, %xmm1, %xmm1
	vpunpcklqdq	%xmm1, %xmm0, %xmm0 # xmm0 = xmm0[0],xmm1[0]
	vmovdqa	%xmm0, 2680(%rsp,%rax)
	vpaddb	%xmm5, %xmm2, %xmm0
	vpshufb	%xmm8, %xmm0, %xmm0
	vpaddb	%xmm5, %xmm3, %xmm1
	vpshufb	%xmm8, %xmm1, %xmm1
	vpunpcklqdq	%xmm1, %xmm0, %xmm0 # xmm0 = xmm0[0],xmm1[0]
	vmovdqa	%xmm0, 2696(%rsp,%rax)
	addq	$32, %rax
	cmpq	$664, %rax              # imm = 0x298
	jne	.LBB0_2
# %bb.3:                                #   in Loop: Header=BB0_1 Depth=1
	movl	2560(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3344(%rsp)
	movl	2564(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3345(%rsp)
	movl	2568(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3346(%rsp)
	movl	2572(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3347(%rsp)
	movl	2576(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3348(%rsp)
	movl	2580(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3349(%rsp)
	movl	2584(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3350(%rsp)
	movl	2588(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3351(%rsp)
	movl	2592(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3352(%rsp)
	movl	2596(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3353(%rsp)
	movl	2600(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3354(%rsp)
	movl	2604(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3355(%rsp)
	movl	2608(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3356(%rsp)
	xorl	%edx, %edx
	xorl	%ecx, %ecx
	movq	%r12, %rdi
	movq	%r13, %rsi
	vzeroupper
	callq	crypto_core_inv3sntrup653_avx@PLT
	cmpb	$0, 4669(%rsp)
	jne	.LBB0_1
# %bb.4:
	movq	%rsp, %r15
	movl	$2612, %esi             # imm = 0xA34
	movq	%r15, %rdi
	callq	randombytes@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_653xint32_little@PLT
	vbroadcastss	.LCPI0_3(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	(%rsp), %ymm0, %ymm1
	vandps	32(%rsp), %ymm0, %ymm2
	vandps	64(%rsp), %ymm0, %ymm3
	vandps	96(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, (%rsp)
	vmovups	%ymm2, 32(%rsp)
	vmovups	%ymm3, 64(%rsp)
	vmovups	%ymm4, 96(%rsp)
	vandps	128(%rsp), %ymm0, %ymm1
	vandps	160(%rsp), %ymm0, %ymm2
	vandps	192(%rsp), %ymm0, %ymm3
	vandps	224(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 128(%rsp)
	vmovups	%ymm2, 160(%rsp)
	vmovups	%ymm3, 192(%rsp)
	vmovups	%ymm4, 224(%rsp)
	vandps	256(%rsp), %ymm0, %ymm1
	vandps	288(%rsp), %ymm0, %ymm2
	vandps	320(%rsp), %ymm0, %ymm3
	vandps	352(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 256(%rsp)
	vmovups	%ymm2, 288(%rsp)
	vmovups	%ymm3, 320(%rsp)
	vmovups	%ymm4, 352(%rsp)
	vandps	384(%rsp), %ymm0, %ymm1
	vandps	416(%rsp), %ymm0, %ymm2
	vandps	448(%rsp), %ymm0, %ymm3
	vandps	480(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 384(%rsp)
	vmovups	%ymm2, 416(%rsp)
	vmovups	%ymm3, 448(%rsp)
	vmovups	%ymm4, 480(%rsp)
	vandps	512(%rsp), %ymm0, %ymm1
	vandps	544(%rsp), %ymm0, %ymm2
	vandps	576(%rsp), %ymm0, %ymm3
	vandps	608(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 512(%rsp)
	vmovups	%ymm2, 544(%rsp)
	vmovups	%ymm3, 576(%rsp)
	vmovups	%ymm4, 608(%rsp)
	vandps	640(%rsp), %ymm0, %ymm1
	vandps	672(%rsp), %ymm0, %ymm2
	vandps	704(%rsp), %ymm0, %ymm3
	vandps	736(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 640(%rsp)
	vmovups	%ymm2, 672(%rsp)
	vmovups	%ymm3, 704(%rsp)
	vmovups	%ymm4, 736(%rsp)
	vandps	768(%rsp), %ymm0, %ymm1
	vandps	800(%rsp), %ymm0, %ymm2
	vandps	832(%rsp), %ymm0, %ymm3
	vandps	864(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 768(%rsp)
	vmovups	%ymm2, 800(%rsp)
	vmovups	%ymm3, 832(%rsp)
	vmovups	%ymm4, 864(%rsp)
	vandps	896(%rsp), %ymm0, %ymm1
	vandps	928(%rsp), %ymm0, %ymm2
	vandps	960(%rsp), %ymm0, %ymm3
	vandps	992(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 896(%rsp)
	vmovups	%ymm2, 928(%rsp)
	vmovups	%ymm3, 960(%rsp)
	vmovups	%ymm4, 992(%rsp)
	vandps	1024(%rsp), %ymm0, %ymm1
	vandps	1056(%rsp), %ymm0, %ymm2
	vandps	1088(%rsp), %ymm0, %ymm3
	vandps	1120(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 1024(%rsp)
	vmovups	%ymm2, 1056(%rsp)
	vmovups	%ymm3, 1088(%rsp)
	vmovups	%ymm0, 1120(%rsp)
	vpbroadcastd	.LCPI0_4(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	1152(%rsp), %ymm0, %ymm2
	vpand	1184(%rsp), %ymm0, %ymm3
	vpand	1216(%rsp), %ymm0, %ymm4
	vpand	1248(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI0_5(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1152(%rsp)
	vmovdqu	%ymm3, 1184(%rsp)
	vmovdqu	%ymm4, 1216(%rsp)
	vmovdqu	%ymm5, 1248(%rsp)
	vpand	1280(%rsp), %ymm0, %ymm2
	vpand	1312(%rsp), %ymm0, %ymm3
	vpand	1344(%rsp), %ymm0, %ymm4
	vpand	1376(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1280(%rsp)
	vmovdqu	%ymm3, 1312(%rsp)
	vmovdqu	%ymm4, 1344(%rsp)
	vmovdqu	%ymm5, 1376(%rsp)
	vpand	1408(%rsp), %ymm0, %ymm2
	vpand	1440(%rsp), %ymm0, %ymm3
	vpand	1472(%rsp), %ymm0, %ymm4
	vpand	1504(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1408(%rsp)
	vmovdqu	%ymm3, 1440(%rsp)
	vmovdqu	%ymm4, 1472(%rsp)
	vmovdqu	%ymm5, 1504(%rsp)
	vpand	1536(%rsp), %ymm0, %ymm2
	vpand	1568(%rsp), %ymm0, %ymm3
	vpand	1600(%rsp), %ymm0, %ymm4
	vpand	1632(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1536(%rsp)
	vmovdqu	%ymm3, 1568(%rsp)
	vmovdqu	%ymm4, 1600(%rsp)
	vmovdqu	%ymm5, 1632(%rsp)
	vpand	1664(%rsp), %ymm0, %ymm2
	vpand	1696(%rsp), %ymm0, %ymm3
	vpand	1728(%rsp), %ymm0, %ymm4
	vpand	1760(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1664(%rsp)
	vmovdqu	%ymm3, 1696(%rsp)
	vmovdqu	%ymm4, 1728(%rsp)
	vmovdqu	%ymm5, 1760(%rsp)
	vpand	1792(%rsp), %ymm0, %ymm2
	vpand	1824(%rsp), %ymm0, %ymm3
	vpand	1856(%rsp), %ymm0, %ymm4
	vpand	1888(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1792(%rsp)
	vmovdqu	%ymm3, 1824(%rsp)
	vmovdqu	%ymm4, 1856(%rsp)
	vmovdqu	%ymm5, 1888(%rsp)
	vpand	1920(%rsp), %ymm0, %ymm2
	vpand	1952(%rsp), %ymm0, %ymm3
	vpand	1984(%rsp), %ymm0, %ymm4
	vpand	2016(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1920(%rsp)
	vmovdqu	%ymm3, 1952(%rsp)
	vmovdqu	%ymm4, 1984(%rsp)
	vmovdqu	%ymm5, 2016(%rsp)
	vpand	2048(%rsp), %ymm0, %ymm2
	vpand	2080(%rsp), %ymm0, %ymm3
	vpand	2112(%rsp), %ymm0, %ymm4
	vpand	2144(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2048(%rsp)
	vmovdqu	%ymm3, 2080(%rsp)
	vmovdqu	%ymm4, 2112(%rsp)
	vmovdqu	%ymm5, 2144(%rsp)
	vpand	2176(%rsp), %ymm0, %ymm2
	vpand	2208(%rsp), %ymm0, %ymm3
	vpand	2240(%rsp), %ymm0, %ymm4
	vpand	2272(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2176(%rsp)
	vmovdqu	%ymm3, 2208(%rsp)
	vmovdqu	%ymm4, 2240(%rsp)
	vmovdqu	%ymm5, 2272(%rsp)
	vpand	2304(%rsp), %ymm0, %ymm2
	vpand	2336(%rsp), %ymm0, %ymm3
	vpand	2368(%rsp), %ymm0, %ymm4
	vpand	2400(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2304(%rsp)
	vmovdqu	%ymm3, 2336(%rsp)
	vmovdqu	%ymm4, 2368(%rsp)
	vmovdqu	%ymm5, 2400(%rsp)
	vpand	2432(%rsp), %ymm0, %ymm2
	vpand	2464(%rsp), %ymm0, %ymm3
	vpand	2496(%rsp), %ymm0, %ymm4
	vpand	2528(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 2432(%rsp)
	vmovdqu	%ymm3, 2464(%rsp)
	vmovdqu	%ymm4, 2496(%rsp)
	vmovdqu	%ymm0, 2528(%rsp)
	movl	2560(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2560(%rsp)
	movl	2564(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2564(%rsp)
	movl	2568(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2568(%rsp)
	movl	2572(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2572(%rsp)
	movl	2576(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2576(%rsp)
	movl	2580(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2580(%rsp)
	movl	2584(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2584(%rsp)
	movl	2588(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2588(%rsp)
	movl	2592(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2592(%rsp)
	movl	2596(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2596(%rsp)
	movl	2600(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2600(%rsp)
	movl	2604(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2604(%rsp)
	movl	2608(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2608(%rsp)
	movl	$653, %esi              # imm = 0x28D
	movq	%r15, %rdi
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	movl	$24, %eax
	vmovdqa	.LCPI0_6(%rip), %ymm0   # ymm0 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vmovdqa	.LCPI0_7(%rip), %xmm1   # xmm1 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm2, %xmm2, %xmm2
	vmovdqa	.LCPI0_2(%rip), %xmm7   # xmm7 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB0_5:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	-96(%rsp,%rax,4), %ymm3
	vmovdqu	-64(%rsp,%rax,4), %ymm4
	vmovdqu	-32(%rsp,%rax,4), %ymm5
	vmovdqu	(%rsp,%rax,4), %ymm6
	vpshufb	%ymm0, %ymm3, %ymm3
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpshufb	%ymm0, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm0, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpand	%xmm1, %xmm3, %xmm3
	vpand	%xmm1, %xmm4, %xmm4
	vpand	%xmm1, %xmm5, %xmm5
	vpand	%xmm1, %xmm6, %xmm6
	vpaddb	%xmm2, %xmm3, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpaddb	%xmm2, %xmm4, %xmm4
	vpshufb	%xmm7, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 3336(%rsp,%rax)
	vpaddb	%xmm2, %xmm5, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpaddb	%xmm2, %xmm6, %xmm4
	vpshufb	%xmm7, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 3352(%rsp,%rax)
	addq	$32, %rax
	cmpq	$664, %rax              # imm = 0x298
	jne	.LBB0_5
# %bb.6:
	movb	2560(%rsp), %al
	movb	2564(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4000(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 4001(%rsp)
	movb	2568(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4002(%rsp)
	movb	2572(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4003(%rsp)
	movb	2576(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4004(%rsp)
	movb	2580(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4005(%rsp)
	movb	2584(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4006(%rsp)
	movb	2588(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4007(%rsp)
	movb	2592(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4008(%rsp)
	movb	2596(%rsp), %al
	movb	2600(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4009(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 4010(%rsp)
	movb	2604(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4011(%rsp)
	movb	2608(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4012(%rsp)
	xorl	%ebp, %ebp
	movq	%rsp, %r15
	leaq	3360(%rsp), %rsi
	xorl	%edx, %edx
	xorl	%ecx, %ecx
	movq	%r15, %rdi
	vzeroupper
	callq	crypto_core_invsntrup653_avx@PLT
	leaq	5984(%rsp), %r12
	movq	%r12, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_653xint16_little@PLT
	leaq	7296(%rsp), %r15
	movq	%r15, %rdi
	movq	%r12, %rsi
	callq	crypto_encode_653xint16_little@PLT
	movq	%rsp, %r12
	leaq	2704(%rsp), %rdx
	xorl	%ecx, %ecx
	movq	%r12, %rdi
	movq	%r15, %rsi
	callq	crypto_core_multsntrup653_avx@PLT
	leaq	4672(%rsp), %r15
	movq	%r15, %rdi
	movq	%r12, %rsi
	callq	crypto_decode_653xint16_little@PLT
	movq	%r14, %rdi
	movq	%r15, %rsi
	callq	crypto_encode_653x4621_portable@PLT
	leaq	328(%rbx), %rax
	leaq	1322(%rbx), %r15
	leaq	994(%r14), %rcx
	cmpq	%rcx, %rax
	jae	.LBB0_8
# %bb.7:
	cmpq	%r14, %r15
	ja	.LBB0_9
.LBB0_8:
	vmovups	(%r14), %ymm0
	vmovups	32(%r14), %ymm1
	vmovups	64(%r14), %ymm2
	vmovups	96(%r14), %ymm3
	vmovups	%ymm0, 328(%rbx)
	vmovups	%ymm1, 360(%rbx)
	vmovups	%ymm2, 392(%rbx)
	vmovups	%ymm3, 424(%rbx)
	vmovups	128(%r14), %ymm0
	vmovups	160(%r14), %ymm1
	vmovups	192(%r14), %ymm2
	vmovups	224(%r14), %ymm3
	vmovups	%ymm0, 456(%rbx)
	vmovups	%ymm1, 488(%rbx)
	vmovups	%ymm2, 520(%rbx)
	vmovups	%ymm3, 552(%rbx)
	vmovups	256(%r14), %ymm0
	vmovups	288(%r14), %ymm1
	vmovups	320(%r14), %ymm2
	vmovups	352(%r14), %ymm3
	vmovups	%ymm0, 584(%rbx)
	vmovups	%ymm1, 616(%rbx)
	vmovups	%ymm2, 648(%rbx)
	vmovups	%ymm3, 680(%rbx)
	vmovups	384(%r14), %ymm0
	vmovups	416(%r14), %ymm1
	vmovups	448(%r14), %ymm2
	vmovups	480(%r14), %ymm3
	vmovups	%ymm0, 712(%rbx)
	vmovups	%ymm1, 744(%rbx)
	vmovups	%ymm2, 776(%rbx)
	vmovups	%ymm3, 808(%rbx)
	vmovups	512(%r14), %ymm0
	vmovups	544(%r14), %ymm1
	vmovups	576(%r14), %ymm2
	vmovups	608(%r14), %ymm3
	vmovups	%ymm0, 840(%rbx)
	vmovups	%ymm1, 872(%rbx)
	vmovups	%ymm2, 904(%rbx)
	vmovups	%ymm3, 936(%rbx)
	vmovups	640(%r14), %ymm0
	vmovups	672(%r14), %ymm1
	vmovups	704(%r14), %ymm2
	vmovups	736(%r14), %ymm3
	vmovups	%ymm0, 968(%rbx)
	vmovups	%ymm1, 1000(%rbx)
	vmovups	%ymm2, 1032(%rbx)
	vmovups	%ymm3, 1064(%rbx)
	vmovdqu	768(%r14), %ymm0
	vmovdqu	800(%r14), %ymm1
	vmovdqu	832(%r14), %ymm2
	vmovdqu	864(%r14), %ymm3
	vmovdqu	%ymm0, 1096(%rbx)
	vmovdqu	%ymm1, 1128(%rbx)
	vmovdqu	%ymm2, 1160(%rbx)
	vmovdqu	%ymm3, 1192(%rbx)
	movl	$896, %ebp              # imm = 0x380
.LBB0_9:
	movq	$-2, %rax
	.p2align	4, 0x90
.LBB0_10:                               # =>This Inner Loop Header: Depth=1
	movzbl	(%r14,%rbp), %ecx
	movb	%cl, 328(%rbx,%rbp)
	addq	$1, %rbp
	addq	$1, %rax
	jne	.LBB0_10
	.p2align	4, 0x90
.LBB0_11:                               # =>This Inner Loop Header: Depth=1
	movzbl	(%r14,%rbp), %eax
	movb	%al, 328(%rbx,%rbp)
	movzbl	1(%r14,%rbp), %eax
	movb	%al, 329(%rbx,%rbp)
	movzbl	2(%r14,%rbp), %eax
	movb	%al, 330(%rbx,%rbp)
	movzbl	3(%r14,%rbp), %eax
	movb	%al, 331(%rbx,%rbp)
	addq	$4, %rbp
	cmpq	$994, %rbp              # imm = 0x3E2
	jne	.LBB0_11
# %bb.12:
	leaq	327(%rbx), %rsi
	movb	$4, 327(%rbx)
	movq	%rsp, %rdi
	movl	$995, %edx              # imm = 0x3E3
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	(%rsp), %ymm0
	vmovups	%ymm0, 1486(%rbx)
	leaq	3360(%rsp), %rsi
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_encode_653x3_ref@PLT
	addq	$164, %rbx
	leaq	4016(%rsp), %rsi
	movq	%rbx, %rdi
	callq	crypto_encode_653x3_ref@PLT
	movl	$164, %esi
	movq	%r15, %rdi
	callq	randombytes@PLT
	xorl	%eax, %eax
	addq	$8616, %rsp             # imm = 0x21A8
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	retq
.Lfunc_end0:
	.size	crypto_kem_keypair, .Lfunc_end0-crypto_kem_keypair
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_enc
.LCPI1_0:
	.long	4294967294              # 0xfffffffe
.LCPI1_1:
	.long	4294967292              # 0xfffffffc
.LCPI1_2:
	.long	1                       # 0x1
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI1_3:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI1_4:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
.LCPI1_5:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.text
	.globl	crypto_kem_enc
	.p2align	4, 0x90
	.type	crypto_kem_enc,@function
crypto_kem_enc:                         # @crypto_kem_enc
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$8440, %rsp             # imm = 0x20F8
	.cfi_def_cfa_offset 8496
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r15
	movq	%rsi, %r14
	movq	%rdi, %r12
	leaq	4801(%rsp), %rdi
	movl	$994, %edx              # imm = 0x3E2
	movq	%r15, %rsi
	callq	memcpy@PLT
	movb	$4, 4800(%rsp)
	leaq	3488(%rsp), %rdi
	leaq	4800(%rsp), %rsi
	movl	$995, %edx              # imm = 0x3E3
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	3488(%rsp), %ymm0
	vmovups	%ymm0, 2624(%rsp)
	movq	%rsp, %rbx
	movl	$2612, %esi             # imm = 0xA34
	movq	%rbx, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%rbx, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_653xint32_little@PLT
	vbroadcastss	.LCPI1_0(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	(%rsp), %ymm0, %ymm1
	vandps	32(%rsp), %ymm0, %ymm2
	vandps	64(%rsp), %ymm0, %ymm3
	vandps	96(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, (%rsp)
	vmovups	%ymm2, 32(%rsp)
	vmovups	%ymm3, 64(%rsp)
	vmovups	%ymm4, 96(%rsp)
	vandps	128(%rsp), %ymm0, %ymm1
	vandps	160(%rsp), %ymm0, %ymm2
	vandps	192(%rsp), %ymm0, %ymm3
	vandps	224(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 128(%rsp)
	vmovups	%ymm2, 160(%rsp)
	vmovups	%ymm3, 192(%rsp)
	vmovups	%ymm4, 224(%rsp)
	vandps	256(%rsp), %ymm0, %ymm1
	vandps	288(%rsp), %ymm0, %ymm2
	vandps	320(%rsp), %ymm0, %ymm3
	vandps	352(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 256(%rsp)
	vmovups	%ymm2, 288(%rsp)
	vmovups	%ymm3, 320(%rsp)
	vmovups	%ymm4, 352(%rsp)
	vandps	384(%rsp), %ymm0, %ymm1
	vandps	416(%rsp), %ymm0, %ymm2
	vandps	448(%rsp), %ymm0, %ymm3
	vandps	480(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 384(%rsp)
	vmovups	%ymm2, 416(%rsp)
	vmovups	%ymm3, 448(%rsp)
	vmovups	%ymm4, 480(%rsp)
	vandps	512(%rsp), %ymm0, %ymm1
	vandps	544(%rsp), %ymm0, %ymm2
	vandps	576(%rsp), %ymm0, %ymm3
	vandps	608(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 512(%rsp)
	vmovups	%ymm2, 544(%rsp)
	vmovups	%ymm3, 576(%rsp)
	vmovups	%ymm4, 608(%rsp)
	vandps	640(%rsp), %ymm0, %ymm1
	vandps	672(%rsp), %ymm0, %ymm2
	vandps	704(%rsp), %ymm0, %ymm3
	vandps	736(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 640(%rsp)
	vmovups	%ymm2, 672(%rsp)
	vmovups	%ymm3, 704(%rsp)
	vmovups	%ymm4, 736(%rsp)
	vandps	768(%rsp), %ymm0, %ymm1
	vandps	800(%rsp), %ymm0, %ymm2
	vandps	832(%rsp), %ymm0, %ymm3
	vandps	864(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 768(%rsp)
	vmovups	%ymm2, 800(%rsp)
	vmovups	%ymm3, 832(%rsp)
	vmovups	%ymm4, 864(%rsp)
	vandps	896(%rsp), %ymm0, %ymm1
	vandps	928(%rsp), %ymm0, %ymm2
	vandps	960(%rsp), %ymm0, %ymm3
	vandps	992(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 896(%rsp)
	vmovups	%ymm2, 928(%rsp)
	vmovups	%ymm3, 960(%rsp)
	vmovups	%ymm4, 992(%rsp)
	vandps	1024(%rsp), %ymm0, %ymm1
	vandps	1056(%rsp), %ymm0, %ymm2
	vandps	1088(%rsp), %ymm0, %ymm3
	vandps	1120(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 1024(%rsp)
	vmovups	%ymm2, 1056(%rsp)
	vmovups	%ymm3, 1088(%rsp)
	vmovups	%ymm0, 1120(%rsp)
	vpbroadcastd	.LCPI1_1(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	1152(%rsp), %ymm0, %ymm2
	vpand	1184(%rsp), %ymm0, %ymm3
	vpand	1216(%rsp), %ymm0, %ymm4
	vpand	1248(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI1_2(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1152(%rsp)
	vmovdqu	%ymm3, 1184(%rsp)
	vmovdqu	%ymm4, 1216(%rsp)
	vmovdqu	%ymm5, 1248(%rsp)
	vpand	1280(%rsp), %ymm0, %ymm2
	vpand	1312(%rsp), %ymm0, %ymm3
	vpand	1344(%rsp), %ymm0, %ymm4
	vpand	1376(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1280(%rsp)
	vmovdqu	%ymm3, 1312(%rsp)
	vmovdqu	%ymm4, 1344(%rsp)
	vmovdqu	%ymm5, 1376(%rsp)
	vpand	1408(%rsp), %ymm0, %ymm2
	vpand	1440(%rsp), %ymm0, %ymm3
	vpand	1472(%rsp), %ymm0, %ymm4
	vpand	1504(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1408(%rsp)
	vmovdqu	%ymm3, 1440(%rsp)
	vmovdqu	%ymm4, 1472(%rsp)
	vmovdqu	%ymm5, 1504(%rsp)
	vpand	1536(%rsp), %ymm0, %ymm2
	vpand	1568(%rsp), %ymm0, %ymm3
	vpand	1600(%rsp), %ymm0, %ymm4
	vpand	1632(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1536(%rsp)
	vmovdqu	%ymm3, 1568(%rsp)
	vmovdqu	%ymm4, 1600(%rsp)
	vmovdqu	%ymm5, 1632(%rsp)
	vpand	1664(%rsp), %ymm0, %ymm2
	vpand	1696(%rsp), %ymm0, %ymm3
	vpand	1728(%rsp), %ymm0, %ymm4
	vpand	1760(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1664(%rsp)
	vmovdqu	%ymm3, 1696(%rsp)
	vmovdqu	%ymm4, 1728(%rsp)
	vmovdqu	%ymm5, 1760(%rsp)
	vpand	1792(%rsp), %ymm0, %ymm2
	vpand	1824(%rsp), %ymm0, %ymm3
	vpand	1856(%rsp), %ymm0, %ymm4
	vpand	1888(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1792(%rsp)
	vmovdqu	%ymm3, 1824(%rsp)
	vmovdqu	%ymm4, 1856(%rsp)
	vmovdqu	%ymm5, 1888(%rsp)
	vpand	1920(%rsp), %ymm0, %ymm2
	vpand	1952(%rsp), %ymm0, %ymm3
	vpand	1984(%rsp), %ymm0, %ymm4
	vpand	2016(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1920(%rsp)
	vmovdqu	%ymm3, 1952(%rsp)
	vmovdqu	%ymm4, 1984(%rsp)
	vmovdqu	%ymm5, 2016(%rsp)
	vpand	2048(%rsp), %ymm0, %ymm2
	vpand	2080(%rsp), %ymm0, %ymm3
	vpand	2112(%rsp), %ymm0, %ymm4
	vpand	2144(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2048(%rsp)
	vmovdqu	%ymm3, 2080(%rsp)
	vmovdqu	%ymm4, 2112(%rsp)
	vmovdqu	%ymm5, 2144(%rsp)
	vpand	2176(%rsp), %ymm0, %ymm2
	vpand	2208(%rsp), %ymm0, %ymm3
	vpand	2240(%rsp), %ymm0, %ymm4
	vpand	2272(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2176(%rsp)
	vmovdqu	%ymm3, 2208(%rsp)
	vmovdqu	%ymm4, 2240(%rsp)
	vmovdqu	%ymm5, 2272(%rsp)
	vpand	2304(%rsp), %ymm0, %ymm2
	vpand	2336(%rsp), %ymm0, %ymm3
	vpand	2368(%rsp), %ymm0, %ymm4
	vpand	2400(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2304(%rsp)
	vmovdqu	%ymm3, 2336(%rsp)
	vmovdqu	%ymm4, 2368(%rsp)
	vmovdqu	%ymm5, 2400(%rsp)
	vpand	2432(%rsp), %ymm0, %ymm2
	vpand	2464(%rsp), %ymm0, %ymm3
	vpand	2496(%rsp), %ymm0, %ymm4
	vpand	2528(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 2432(%rsp)
	vmovdqu	%ymm3, 2464(%rsp)
	vmovdqu	%ymm4, 2496(%rsp)
	vmovdqu	%ymm0, 2528(%rsp)
	movl	2560(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2560(%rsp)
	movl	2564(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2564(%rsp)
	movl	2568(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2568(%rsp)
	movl	2572(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2572(%rsp)
	movl	2576(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2576(%rsp)
	movl	2580(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2580(%rsp)
	movl	2584(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2584(%rsp)
	movl	2588(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2588(%rsp)
	movl	2592(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2592(%rsp)
	movl	2596(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2596(%rsp)
	movl	2600(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2600(%rsp)
	movl	2604(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2604(%rsp)
	movl	2608(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2608(%rsp)
	movl	$653, %esi              # imm = 0x28D
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	movl	$24, %eax
	vmovdqa	.LCPI1_3(%rip), %ymm0   # ymm0 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vmovdqa	.LCPI1_4(%rip), %xmm1   # xmm1 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm2, %xmm2, %xmm2
	vmovdqa	.LCPI1_5(%rip), %xmm3   # xmm3 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB1_1:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	-96(%rsp,%rax,4), %ymm4
	vmovdqu	-64(%rsp,%rax,4), %ymm5
	vmovdqu	-32(%rsp,%rax,4), %ymm6
	vmovdqu	(%rsp,%rax,4), %ymm7
	vpshufb	%ymm0, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm0, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufb	%ymm0, %ymm7, %ymm7
	vpermq	$232, %ymm7, %ymm7      # ymm7 = ymm7[0,2,2,3]
	vpand	%xmm1, %xmm4, %xmm4
	vpand	%xmm1, %xmm5, %xmm5
	vpand	%xmm1, %xmm6, %xmm6
	vpand	%xmm1, %xmm7, %xmm7
	vpaddb	%xmm2, %xmm4, %xmm4
	vpshufb	%xmm3, %xmm4, %xmm4
	vpaddb	%xmm2, %xmm5, %xmm5
	vpshufb	%xmm3, %xmm5, %xmm5
	vpunpcklqdq	%xmm5, %xmm4, %xmm4 # xmm4 = xmm4[0],xmm5[0]
	vmovdqa	%xmm4, 2632(%rsp,%rax)
	vpaddb	%xmm2, %xmm6, %xmm4
	vpshufb	%xmm3, %xmm4, %xmm4
	vpaddb	%xmm2, %xmm7, %xmm5
	vpshufb	%xmm3, %xmm5, %xmm5
	vpunpcklqdq	%xmm5, %xmm4, %xmm4 # xmm4 = xmm4[0],xmm5[0]
	vmovdqa	%xmm4, 2648(%rsp,%rax)
	addq	$32, %rax
	cmpq	$664, %rax              # imm = 0x298
	jne	.LBB1_1
# %bb.2:
	movb	2560(%rsp), %al
	movb	2564(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3296(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 3297(%rsp)
	movb	2568(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3298(%rsp)
	movb	2572(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3299(%rsp)
	movb	2576(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3300(%rsp)
	movb	2580(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3301(%rsp)
	movb	2584(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3302(%rsp)
	movb	2588(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3303(%rsp)
	movb	2592(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3304(%rsp)
	movb	2596(%rsp), %al
	movb	2600(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3305(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 3306(%rsp)
	movb	2604(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3307(%rsp)
	movb	2608(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3308(%rsp)
	leaq	3313(%rsp), %rdi
	leaq	2656(%rsp), %r13
	movq	%r13, %rsi
	vzeroupper
	callq	crypto_encode_653x3_ref@PLT
	leaq	7120(%rsp), %rbx
	movq	%rbx, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_653x4621_avx@PLT
	leaq	3488(%rsp), %r15
	movq	%r15, %rdi
	movq	%rbx, %rsi
	callq	crypto_encode_653xint16_little@PLT
	movq	%rsp, %rbp
	xorl	%ecx, %ecx
	movq	%rbp, %rdi
	movq	%r15, %rsi
	movq	%r13, %rdx
	callq	crypto_core_multsntrup653_avx@PLT
	leaq	5808(%rsp), %rbx
	movq	%rbx, %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_653xint16_little@PLT
	movq	%r12, %rdi
	movq	%rbx, %rsi
	callq	crypto_encode_653x1541round_ref@PLT
	movb	$3, 3312(%rsp)
	leaq	3488(%rsp), %rbx
	leaq	3312(%rsp), %rbp
	movl	$165, %edx
	movq	%rbx, %rdi
	movq	%rbp, %rsi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	3488(%rsp), %ymm0
	vmovups	%ymm0, 1(%rsp)
	vmovups	2624(%rsp), %ymm0
	vmovups	%ymm0, 33(%rsp)
	movb	$2, (%rsp)
	movq	%rsp, %rsi
	movl	$65, %edx
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	3488(%rsp), %ymm0
	vmovups	%ymm0, 865(%r12)
	movb	$3, 3312(%rsp)
	movl	$165, %edx
	movq	%rbx, %rdi
	movq	%rbp, %rsi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	3488(%rsp), %ymm0
	vmovups	%ymm0, 1(%rsp)
	leaq	33(%rsp), %rdi
	movl	$897, %edx              # imm = 0x381
	movq	%r12, %rsi
	vzeroupper
	callq	memcpy@PLT
	movb	$1, (%rsp)
	movq	%rsp, %rsi
	movl	$930, %edx              # imm = 0x3A2
	movq	%rbx, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	3488(%rsp), %ymm0
	vmovups	%ymm0, (%r14)
	xorl	%eax, %eax
	addq	$8440, %rsp             # imm = 0x20F8
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end1:
	.size	crypto_kem_enc, .Lfunc_end1-crypto_kem_enc
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_dec
.LCPI2_0:
	.long	3                       # 0x3
.LCPI2_1:
	.long	171                     # 0xab
.LCPI2_2:
	.long	4294962675              # 0xffffedf3
.LCPI2_3:
	.long	29045                   # 0x7175
.LCPI2_4:
	.long	67108864                # 0x4000000
.LCPI2_6:
	.long	10923                   # 0x2aab
.LCPI2_7:
	.long	16384                   # 0x4000
.LCPI2_8:
	.long	4294967293              # 0xfffffffd
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI2_5:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
.LCPI2_11:
	.zero	32,1
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI2_9:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
.LCPI2_10:
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.text
	.globl	crypto_kem_dec
	.p2align	4, 0x90
	.type	crypto_kem_dec,@function
crypto_kem_dec:                         # @crypto_kem_dec
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$12728, %rsp            # imm = 0x31B8
	.cfi_def_cfa_offset 12784
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r15
	movq	%rsi, %rbx
	movq	%rdi, 184(%rsp)         # 8-byte Spill
	leaq	9440(%rsp), %r12
	movq	%r12, %rdi
	movq	%rdx, %rsi
	callq	crypto_decode_653x3_ref@PLT
	leaq	164(%r15), %rsi
	leaq	8784(%rsp), %rdi
	callq	crypto_decode_653x3_ref@PLT
	leaq	10096(%rsp), %r13
	movq	%r13, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_653x1541_avx@PLT
	leaq	6160(%rsp), %r14
	movq	%r14, %rdi
	movq	%r13, %rsi
	callq	crypto_encode_653xint16_little@PLT
	xorl	%ebp, %ebp
	leaq	3536(%rsp), %r13
	xorl	%ecx, %ecx
	movq	%r13, %rdi
	movq	%r14, %rsi
	movq	%r12, %rdx
	callq	crypto_core_multsntrup653_avx@PLT
	leaq	4848(%rsp), %rdi
	movq	%r13, %rsi
	callq	crypto_decode_653xint16_little@PLT
	vpbroadcastd	.LCPI2_0(%rip), %ymm1 # ymm1 = [3,3,3,3,3,3,3,3]
	vpbroadcastd	.LCPI2_1(%rip), %ymm2 # ymm2 = [171,171,171,171,171,171,171,171]
	vpbroadcastd	.LCPI2_2(%rip), %ymm3 # ymm3 = [4294962675,4294962675,4294962675,4294962675,4294962675,4294962675,4294962675,4294962675]
	vpbroadcastd	.LCPI2_3(%rip), %ymm4 # ymm4 = [29045,29045,29045,29045,29045,29045,29045,29045]
	vpbroadcastd	.LCPI2_4(%rip), %ymm5 # ymm5 = [67108864,67108864,67108864,67108864,67108864,67108864,67108864,67108864]
	vmovdqa	.LCPI2_5(%rip), %ymm0   # ymm0 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	.p2align	4, 0x90
.LBB2_1:                                # =>This Inner Loop Header: Depth=1
	vpmovsxwd	4848(%rsp,%rbp,2), %ymm6
	vpmulld	%ymm1, %ymm6, %ymm7
	vpmulld	%ymm2, %ymm6, %ymm6
	vpsrad	$18, %ymm6, %ymm6
	vpmulld	%ymm3, %ymm6, %ymm6
	vpaddd	%ymm7, %ymm6, %ymm6
	vpmulld	%ymm4, %ymm6, %ymm7
	vpaddd	%ymm5, %ymm7, %ymm7
	vpsrad	$27, %ymm7, %ymm7
	vpmulld	%ymm3, %ymm7, %ymm7
	vpaddd	%ymm6, %ymm7, %ymm6
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vmovdqa	%xmm6, 2224(%rsp,%rbp,2)
	addq	$8, %rbp
	cmpq	$648, %rbp              # imm = 0x288
	jne	.LBB2_1
# %bb.2:
	movswl	6144(%rsp), %eax
	leal	(%rax,%rax,2), %ecx
	imull	$171, %eax, %eax
	sarl	$18, %eax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	addl	%ecx, %eax
	imull	$29045, %eax, %ecx      # imm = 0x7175
	addl	$67108864, %ecx         # imm = 0x4000000
	sarl	$27, %ecx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	movw	%cx, 3520(%rsp)
	movswl	6146(%rsp), %eax
	leal	(%rax,%rax,2), %ecx
	imull	$171, %eax, %eax
	sarl	$18, %eax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	addl	%ecx, %eax
	imull	$29045, %eax, %ecx      # imm = 0x7175
	addl	$67108864, %ecx         # imm = 0x4000000
	sarl	$27, %ecx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	movw	%cx, 3522(%rsp)
	movswl	6148(%rsp), %eax
	leal	(%rax,%rax,2), %ecx
	imull	$171, %eax, %eax
	sarl	$18, %eax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	addl	%ecx, %eax
	imull	$29045, %eax, %ecx      # imm = 0x7175
	addl	$67108864, %ecx         # imm = 0x4000000
	sarl	$27, %ecx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	movw	%cx, 3524(%rsp)
	movswl	6150(%rsp), %eax
	leal	(%rax,%rax,2), %ecx
	imull	$171, %eax, %eax
	sarl	$18, %eax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	addl	%ecx, %eax
	imull	$29045, %eax, %ecx      # imm = 0x7175
	addl	$67108864, %ecx         # imm = 0x4000000
	sarl	$27, %ecx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	movw	%cx, 3526(%rsp)
	movswl	6152(%rsp), %eax
	leal	(%rax,%rax,2), %ecx
	imull	$171, %eax, %eax
	sarl	$18, %eax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	addl	%ecx, %eax
	imull	$29045, %eax, %ecx      # imm = 0x7175
	addl	$67108864, %ecx         # imm = 0x4000000
	sarl	$27, %ecx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	movw	%cx, 3528(%rsp)
	leaq	328(%r15), %r12
	leaq	1486(%r15), %rax
	movq	%rax, 176(%rsp)         # 8-byte Spill
	vpbroadcastd	.LCPI2_6(%rip), %ymm1 # ymm1 = [10923,10923,10923,10923,10923,10923,10923,10923]
	vpbroadcastd	.LCPI2_7(%rip), %ymm2 # ymm2 = [16384,16384,16384,16384,16384,16384,16384,16384]
	movl	$24, %eax
	vpbroadcastd	.LCPI2_8(%rip), %ymm3 # ymm3 = [4294967293,4294967293,4294967293,4294967293,4294967293,4294967293,4294967293,4294967293]
	vmovdqa	.LCPI2_9(%rip), %xmm4   # xmm4 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB2_3:                                # =>This Inner Loop Header: Depth=1
	vpmovsxwd	2176(%rsp,%rax,2), %ymm5
	vpmovsxwd	2192(%rsp,%rax,2), %ymm6
	vpmovsxwd	2208(%rsp,%rax,2), %ymm7
	vpmovsxwd	2224(%rsp,%rax,2), %ymm8
	vpmulld	%ymm1, %ymm5, %ymm9
	vpmulld	%ymm1, %ymm6, %ymm10
	vpmulld	%ymm1, %ymm7, %ymm11
	vpmulld	%ymm1, %ymm8, %ymm12
	vpaddd	%ymm2, %ymm9, %ymm9
	vpaddd	%ymm2, %ymm10, %ymm10
	vpaddd	%ymm2, %ymm11, %ymm11
	vpaddd	%ymm2, %ymm12, %ymm12
	vpsrld	$15, %ymm9, %ymm9
	vpsrld	$15, %ymm10, %ymm10
	vpsrld	$15, %ymm11, %ymm11
	vpsrld	$15, %ymm12, %ymm12
	vpmulld	%ymm3, %ymm9, %ymm9
	vpmulld	%ymm3, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm12, %ymm12
	vpaddd	%ymm5, %ymm9, %ymm5
	vpaddd	%ymm6, %ymm10, %ymm6
	vpaddd	%ymm7, %ymm11, %ymm7
	vpaddd	%ymm8, %ymm12, %ymm8
	vpshufb	%ymm0, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufb	%ymm0, %ymm7, %ymm7
	vpermq	$232, %ymm7, %ymm7      # ymm7 = ymm7[0,2,2,3]
	vpshufb	%ymm0, %ymm8, %ymm8
	vpermq	$232, %ymm8, %ymm8      # ymm8 = ymm8[0,2,2,3]
	vpshufb	%xmm4, %xmm5, %xmm5
	vpshufb	%xmm4, %xmm6, %xmm6
	vpunpcklqdq	%xmm6, %xmm5, %xmm5 # xmm5 = xmm5[0],xmm6[0]
	vmovdqa	%xmm5, 1544(%rsp,%rax)
	vpshufb	%xmm4, %xmm7, %xmm5
	vpshufb	%xmm4, %xmm8, %xmm6
	vpunpcklqdq	%xmm6, %xmm5, %xmm5 # xmm5 = xmm5[0],xmm6[0]
	vmovdqa	%xmm5, 1560(%rsp,%rax)
	addq	$32, %rax
	cmpq	$664, %rax              # imm = 0x298
	jne	.LBB2_3
# %bb.4:
	movswl	3504(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2208(%rsp)
	movswl	3506(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2209(%rsp)
	movswl	3508(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2210(%rsp)
	movswl	3510(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2211(%rsp)
	movswl	3512(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2212(%rsp)
	movswl	3514(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2213(%rsp)
	movswl	3516(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2214(%rsp)
	movswl	3518(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2215(%rsp)
	movswl	3520(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2216(%rsp)
	movswl	3522(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2217(%rsp)
	movswl	3524(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2218(%rsp)
	movswl	3526(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2219(%rsp)
	movswl	3528(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2220(%rsp)
	leaq	192(%rsp), %rdi
	leaq	1568(%rsp), %rsi
	leaq	8784(%rsp), %rdx
	xorl	%ecx, %ecx
	vzeroupper
	callq	crypto_core_mult3sntrup653_avx@PLT
	vpxor	%xmm0, %xmm0, %xmm0
	movl	$24, %eax
	vmovdqa	.LCPI2_10(%rip), %xmm8  # xmm8 = [1,1,1,1,1,1,1,1]
	vpxor	%xmm2, %xmm2, %xmm2
	vpxor	%xmm3, %xmm3, %xmm3
	vpxor	%xmm4, %xmm4, %xmm4
	.p2align	4, 0x90
.LBB2_5:                                # =>This Inner Loop Header: Depth=1
	vpmovzxbw	168(%rsp,%rax), %xmm5 # xmm5 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	176(%rsp,%rax), %xmm6 # xmm6 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	184(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	192(%rsp,%rax), %xmm1 # xmm1 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpand	%xmm8, %xmm5, %xmm5
	vpackuswb	%xmm0, %xmm5, %xmm5
	vpand	%xmm8, %xmm6, %xmm6
	vpackuswb	%xmm0, %xmm6, %xmm6
	vpand	%xmm8, %xmm7, %xmm7
	vpackuswb	%xmm0, %xmm7, %xmm7
	vpand	%xmm8, %xmm1, %xmm1
	vpackuswb	%xmm0, %xmm1, %xmm1
	vpmovzxbd	%xmm5, %ymm5    # ymm5 = xmm5[0],zero,zero,zero,xmm5[1],zero,zero,zero,xmm5[2],zero,zero,zero,xmm5[3],zero,zero,zero,xmm5[4],zero,zero,zero,xmm5[5],zero,zero,zero,xmm5[6],zero,zero,zero,xmm5[7],zero,zero,zero
	vpaddd	%ymm5, %ymm0, %ymm0
	vpmovzxbd	%xmm6, %ymm5    # ymm5 = xmm6[0],zero,zero,zero,xmm6[1],zero,zero,zero,xmm6[2],zero,zero,zero,xmm6[3],zero,zero,zero,xmm6[4],zero,zero,zero,xmm6[5],zero,zero,zero,xmm6[6],zero,zero,zero,xmm6[7],zero,zero,zero
	vpaddd	%ymm5, %ymm2, %ymm2
	vpmovzxbd	%xmm7, %ymm5    # ymm5 = xmm7[0],zero,zero,zero,xmm7[1],zero,zero,zero,xmm7[2],zero,zero,zero,xmm7[3],zero,zero,zero,xmm7[4],zero,zero,zero,xmm7[5],zero,zero,zero,xmm7[6],zero,zero,zero,xmm7[7],zero,zero,zero
	vpaddd	%ymm5, %ymm3, %ymm3
	vpmovzxbd	%xmm1, %ymm1    # ymm1 = xmm1[0],zero,zero,zero,xmm1[1],zero,zero,zero,xmm1[2],zero,zero,zero,xmm1[3],zero,zero,zero,xmm1[4],zero,zero,zero,xmm1[5],zero,zero,zero,xmm1[6],zero,zero,zero,xmm1[7],zero,zero,zero
	vpaddd	%ymm1, %ymm4, %ymm4
	addq	$32, %rax
	cmpq	$664, %rax              # imm = 0x298
	jne	.LBB2_5
# %bb.6:
	vpaddd	%ymm0, %ymm2, %ymm0
	vpaddd	%ymm0, %ymm3, %ymm0
	vpaddd	%ymm0, %ymm4, %ymm0
	vextracti128	$1, %ymm0, %xmm1
	vpaddd	%ymm1, %ymm0, %ymm0
	vpshufd	$78, %xmm0, %xmm1       # xmm1 = xmm0[2,3,0,1]
	vpaddd	%ymm1, %ymm0, %ymm0
	vphaddd	%ymm0, %ymm0, %ymm0
	vmovd	%xmm0, %eax
	movzbl	832(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	833(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	834(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	835(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	836(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	837(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	838(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	839(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	840(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	841(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	842(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	843(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	844(%rsp), %ecx
	andl	$1, %ecx
	leal	(%rcx,%rax), %eax
	addl	$65248, %eax            # imm = 0xFEE0
	movzwl	%ax, %eax
	negl	%eax
	sarl	$31, %eax
	vmovd	%eax, %xmm0
	vpbroadcastb	%xmm0, %ymm0
	vmovdqu	192(%rsp), %ymm1
	vmovdqu	224(%rsp), %ymm2
	vmovdqu	256(%rsp), %ymm3
	vmovdqu	288(%rsp), %ymm4
	vmovdqa	.LCPI2_11(%rip), %ymm5  # ymm5 = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]
	vpblendvb	%ymm0, %ymm5, %ymm1, %ymm1
	vpblendvb	%ymm0, %ymm5, %ymm2, %ymm2
	vpblendvb	%ymm0, %ymm5, %ymm3, %ymm3
	vpblendvb	%ymm0, %ymm5, %ymm4, %ymm4
	vmovdqu	320(%rsp), %ymm6
	vmovdqu	352(%rsp), %ymm7
	vmovdqu	384(%rsp), %ymm8
	vmovdqu	416(%rsp), %ymm9
	vpblendvb	%ymm0, %ymm5, %ymm6, %ymm6
	vpblendvb	%ymm0, %ymm5, %ymm7, %ymm7
	vpblendvb	%ymm0, %ymm5, %ymm8, %ymm8
	vpblendvb	%ymm0, %ymm5, %ymm9, %ymm0
	vmovdqu	%ymm1, 912(%rsp)
	vmovdqu	%ymm2, 944(%rsp)
	vmovdqu	%ymm3, 976(%rsp)
	vmovdqu	%ymm4, 1008(%rsp)
	vmovdqu	%ymm6, 1040(%rsp)
	vmovdqu	%ymm7, 1072(%rsp)
	vmovdqu	%ymm8, 1104(%rsp)
	vmovdqu	%ymm0, 1136(%rsp)
	movb	448(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1168(%rsp)
	movb	449(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1169(%rsp)
	movb	450(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1170(%rsp)
	movb	451(%rsp), %dl
	movb	452(%rsp), %sil
	movl	%edx, %ecx
	xorb	$1, %cl
	andb	%al, %cl
	xorb	%dl, %cl
	movb	%cl, 1171(%rsp)
	movl	%esi, %ecx
	xorb	$1, %cl
	andb	%al, %cl
	xorb	%sil, %cl
	movb	%cl, 1172(%rsp)
	movb	453(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1173(%rsp)
	movb	454(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1174(%rsp)
	movb	455(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1175(%rsp)
	movb	456(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1176(%rsp)
	movb	457(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1177(%rsp)
	movb	458(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1178(%rsp)
	movb	459(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1179(%rsp)
	movb	460(%rsp), %dl
	movb	461(%rsp), %sil
	movl	%edx, %ecx
	xorb	$1, %cl
	andb	%al, %cl
	xorb	%dl, %cl
	movb	%cl, 1180(%rsp)
	movl	%esi, %ecx
	xorb	$1, %cl
	andb	%al, %cl
	xorb	%sil, %cl
	movb	%cl, 1181(%rsp)
	movb	462(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1182(%rsp)
	movb	463(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1183(%rsp)
	movb	464(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1184(%rsp)
	movb	465(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1185(%rsp)
	movb	466(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1186(%rsp)
	movb	467(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1187(%rsp)
	movb	468(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1188(%rsp)
	movb	469(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1189(%rsp)
	movb	470(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1190(%rsp)
	movb	471(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1191(%rsp)
	movb	472(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1192(%rsp)
	movb	473(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1193(%rsp)
	movb	474(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1194(%rsp)
	movb	475(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1195(%rsp)
	movb	476(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1196(%rsp)
	movb	477(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1197(%rsp)
	movb	478(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1198(%rsp)
	movb	479(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	notb	%al
	vmovd	%eax, %xmm0
	vpbroadcastb	%xmm0, %ymm0
	vpand	480(%rsp), %ymm0, %ymm1
	vpand	512(%rsp), %ymm0, %ymm2
	vpand	544(%rsp), %ymm0, %ymm3
	movb	%dl, 1199(%rsp)
	vpand	576(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1200(%rsp)
	vmovdqu	%ymm2, 1232(%rsp)
	vmovdqu	%ymm3, 1264(%rsp)
	vpand	608(%rsp), %ymm0, %ymm1
	vpand	640(%rsp), %ymm0, %ymm2
	vpand	672(%rsp), %ymm0, %ymm3
	vmovdqu	%ymm4, 1296(%rsp)
	vpand	704(%rsp), %ymm0, %ymm0
	vmovdqu	%ymm1, 1328(%rsp)
	vmovdqu	%ymm2, 1360(%rsp)
	vmovdqu	%ymm3, 1392(%rsp)
	vmovdqu	%ymm0, 1424(%rsp)
	xorl	%ecx, %ecx
	jmp	.LBB2_7
	.p2align	4, 0x90
.LBB2_11:                               #   in Loop: Header=BB2_7 Depth=1
	movzbl	737(%rsp,%rcx), %edx
	andb	%al, %dl
	movb	%dl, 1457(%rsp,%rcx)
	movzbl	738(%rsp,%rcx), %edx
	andb	%al, %dl
	movb	%dl, 1458(%rsp,%rcx)
	movzbl	739(%rsp,%rcx), %edx
	andb	%al, %dl
	movb	%dl, 1459(%rsp,%rcx)
	addq	$4, %rcx
.LBB2_7:                                # =>This Inner Loop Header: Depth=1
	movzbl	736(%rsp,%rcx), %edx
	andb	%al, %dl
	movb	%dl, 1456(%rsp,%rcx)
	cmpq	$108, %rcx
	jne	.LBB2_11
# %bb.8:
	leaq	1(%rsp), %rdi
	leaq	912(%rsp), %r14
	movq	%r14, %rsi
	vzeroupper
	callq	crypto_encode_653x3_ref@PLT
	leaq	7472(%rsp), %rbp
	movq	%rbp, %rdi
	movq	%r12, %rsi
	callq	crypto_decode_653x4621_avx@PLT
	leaq	6160(%rsp), %r12
	movq	%r12, %rdi
	movq	%rbp, %rsi
	callq	crypto_encode_653xint16_little@PLT
	leaq	3536(%rsp), %r13
	xorl	%ecx, %ecx
	movq	%r13, %rdi
	movq	%r12, %rsi
	movq	%r14, %rdx
	callq	crypto_core_multsntrup653_avx@PLT
	leaq	11408(%rsp), %rbp
	movq	%rbp, %rdi
	movq	%r13, %rsi
	callq	crypto_decode_653xint16_little@PLT
	leaq	3536(%rsp), %rdi
	movq	%rbp, %rsi
	callq	crypto_encode_653x1541round_ref@PLT
	movb	$3, (%rsp)
	leaq	848(%rsp), %rbp
	movq	%rsp, %rsi
	movl	$165, %edx
	movq	%rbp, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	848(%rsp), %ymm0
	vmovups	%ymm0, 6161(%rsp)
	movq	176(%rsp), %rax         # 8-byte Reload
	vmovups	(%rax), %ymm0
	vmovups	%ymm0, 6193(%rsp)
	movb	$2, 6160(%rsp)
	leaq	6160(%rsp), %rsi
	movl	$65, %edx
	movq	%rbp, %rdi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovdqu	848(%rsp), %ymm0
	vmovdqu	%ymm0, 4401(%rsp)
	vpxor	%xmm0, %xmm0, %xmm0
	movl	$24, %eax
	vpxor	%xmm1, %xmm1, %xmm1
	vpxor	%xmm2, %xmm2, %xmm2
	vpxor	%xmm3, %xmm3, %xmm3
	.p2align	4, 0x90
.LBB2_9:                                # =>This Inner Loop Header: Depth=1
	vpmovzxbw	-24(%rbx,%rax), %xmm4 # xmm4 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-16(%rbx,%rax), %xmm5 # xmm5 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-8(%rbx,%rax), %xmm6 # xmm6 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	(%rbx,%rax), %xmm8 # xmm8 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	3512(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm4, %xmm7, %xmm4
	vpackuswb	%xmm0, %xmm4, %xmm4
	vpmovzxbw	3520(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm5, %xmm7, %xmm5
	vpackuswb	%xmm0, %xmm5, %xmm5
	vpmovzxbw	3528(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm6, %xmm7, %xmm6
	vpackuswb	%xmm0, %xmm6, %xmm6
	vpmovzxbw	3536(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm8, %xmm7, %xmm7
	vpackuswb	%xmm0, %xmm7, %xmm7
	vpmovzxbd	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,zero,zero,xmm4[1],zero,zero,zero,xmm4[2],zero,zero,zero,xmm4[3],zero,zero,zero,xmm4[4],zero,zero,zero,xmm4[5],zero,zero,zero,xmm4[6],zero,zero,zero,xmm4[7],zero,zero,zero
	vpor	%ymm4, %ymm0, %ymm0
	vpmovzxbd	%xmm5, %ymm4    # ymm4 = xmm5[0],zero,zero,zero,xmm5[1],zero,zero,zero,xmm5[2],zero,zero,zero,xmm5[3],zero,zero,zero,xmm5[4],zero,zero,zero,xmm5[5],zero,zero,zero,xmm5[6],zero,zero,zero,xmm5[7],zero,zero,zero
	vpor	%ymm4, %ymm1, %ymm1
	vpmovzxbd	%xmm6, %ymm4    # ymm4 = xmm6[0],zero,zero,zero,xmm6[1],zero,zero,zero,xmm6[2],zero,zero,zero,xmm6[3],zero,zero,zero,xmm6[4],zero,zero,zero,xmm6[5],zero,zero,zero,xmm6[6],zero,zero,zero,xmm6[7],zero,zero,zero
	vpor	%ymm4, %ymm2, %ymm2
	vpmovzxbd	%xmm7, %ymm4    # ymm4 = xmm7[0],zero,zero,zero,xmm7[1],zero,zero,zero,xmm7[2],zero,zero,zero,xmm7[3],zero,zero,zero,xmm7[4],zero,zero,zero,xmm7[5],zero,zero,zero,xmm7[6],zero,zero,zero,xmm7[7],zero,zero,zero
	vpor	%ymm4, %ymm3, %ymm3
	addq	$32, %rax
	cmpq	$920, %rax              # imm = 0x398
	jne	.LBB2_9
# %bb.10:
	vpor	%ymm0, %ymm1, %ymm0
	vpor	%ymm0, %ymm2, %ymm0
	vpor	%ymm0, %ymm3, %ymm0
	vextracti128	$1, %ymm0, %xmm1
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$78, %xmm0, %xmm1       # xmm1 = xmm0[2,3,0,1]
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$229, %xmm0, %xmm1      # xmm1 = xmm0[1,1,2,3]
	vpor	%ymm1, %ymm0, %ymm0
	vmovd	%xmm0, %eax
	movb	4432(%rsp), %cl
	xorb	896(%rbx), %cl
	movzbl	%cl, %r14d
	orl	%eax, %r14d
	addl	$-1, %r14d
	shrl	$8, %r14d
	andb	$1, %r14b
	movl	%r14d, %eax
	addb	$-1, %al
	vmovd	%eax, %xmm0
	vpbroadcastb	%xmm0, %ymm0
	vmovdqu	1(%rsp), %ymm1
	vmovdqu	33(%rsp), %ymm2
	vpblendvb	%ymm0, 1322(%r15), %ymm1, %ymm1
	vmovdqu	65(%rsp), %ymm3
	vpblendvb	%ymm0, 1354(%r15), %ymm2, %ymm2
	vmovdqu	97(%rsp), %ymm4
	vpblendvb	%ymm0, 1386(%r15), %ymm3, %ymm3
	vpblendvb	%ymm0, 1418(%r15), %ymm4, %ymm0
	vmovdqu	%ymm1, 1(%rsp)
	vmovdqu	%ymm2, 33(%rsp)
	vmovdqu	%ymm3, 65(%rsp)
	vmovdqu	%ymm0, 97(%rsp)
	movb	129(%rsp), %cl
	movb	1450(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 129(%rsp)
	movb	130(%rsp), %cl
	movb	1451(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 130(%rsp)
	movb	131(%rsp), %cl
	movb	1452(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 131(%rsp)
	movb	132(%rsp), %cl
	movb	1453(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 132(%rsp)
	movb	133(%rsp), %cl
	movb	1454(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 133(%rsp)
	movb	134(%rsp), %cl
	movb	1455(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 134(%rsp)
	movb	135(%rsp), %cl
	movb	1456(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 135(%rsp)
	movb	136(%rsp), %cl
	movb	1457(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 136(%rsp)
	movb	137(%rsp), %cl
	movb	1458(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 137(%rsp)
	movb	138(%rsp), %cl
	movb	1459(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 138(%rsp)
	movb	139(%rsp), %cl
	movb	1460(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 139(%rsp)
	movb	140(%rsp), %cl
	movb	1461(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 140(%rsp)
	movb	141(%rsp), %cl
	movb	1462(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 141(%rsp)
	movb	142(%rsp), %cl
	movb	1463(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 142(%rsp)
	movb	143(%rsp), %cl
	movb	1464(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 143(%rsp)
	movb	144(%rsp), %cl
	movb	1465(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 144(%rsp)
	movb	145(%rsp), %cl
	movb	1466(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 145(%rsp)
	movb	146(%rsp), %cl
	movb	1467(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 146(%rsp)
	movb	147(%rsp), %cl
	movb	1468(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 147(%rsp)
	movb	148(%rsp), %cl
	movb	1469(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 148(%rsp)
	movb	149(%rsp), %cl
	movb	1470(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 149(%rsp)
	movb	150(%rsp), %cl
	movb	1471(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 150(%rsp)
	movb	151(%rsp), %cl
	movb	1472(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 151(%rsp)
	movb	152(%rsp), %cl
	movb	1473(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 152(%rsp)
	movb	153(%rsp), %cl
	movb	1474(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 153(%rsp)
	movb	154(%rsp), %cl
	movb	1475(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 154(%rsp)
	movb	155(%rsp), %cl
	movb	1476(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 155(%rsp)
	movb	156(%rsp), %cl
	movb	1477(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 156(%rsp)
	movb	157(%rsp), %cl
	movb	1478(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 157(%rsp)
	movb	158(%rsp), %cl
	movb	1479(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 158(%rsp)
	movb	159(%rsp), %cl
	movb	1480(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 159(%rsp)
	movb	160(%rsp), %cl
	movb	1481(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 160(%rsp)
	movb	161(%rsp), %cl
	movb	1482(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 161(%rsp)
	movb	162(%rsp), %cl
	movb	1483(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 162(%rsp)
	movb	163(%rsp), %cl
	movb	1484(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 163(%rsp)
	movb	164(%rsp), %cl
	movb	1485(%r15), %dl
	xorb	%cl, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 164(%rsp)
	movb	$3, (%rsp)
	leaq	848(%rsp), %rbp
	movq	%rsp, %rsi
	movl	$165, %edx
	movq	%rbp, %rdi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	848(%rsp), %ymm0
	vmovups	%ymm0, 7473(%rsp)
	leaq	7505(%rsp), %rdi
	movl	$897, %edx              # imm = 0x381
	movq	%rbx, %rsi
	vzeroupper
	callq	memcpy@PLT
	movb	%r14b, 7472(%rsp)
	leaq	7472(%rsp), %rsi
	movl	$930, %edx              # imm = 0x3A2
	movq	%rbp, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	848(%rsp), %ymm0
	movq	184(%rsp), %rax         # 8-byte Reload
	vmovups	%ymm0, (%rax)
	xorl	%eax, %eax
	addq	$12728, %rsp            # imm = 0x31B8
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end2:
	.size	crypto_kem_dec, .Lfunc_end2-crypto_kem_dec
	.cfi_endproc
                                        # -- End function

	.ident	"clang version 7.0.1-8 (tags/RELEASE_701/final)"
	.section	".note.GNU-stack","",@progbits
