	.text
	.file	"kem.c"
	.section	.rodata.cst8,"aM",@progbits,8
	.p2align	3               # -- Begin function crypto_kem_keypair
.LCPI0_0:
	.quad	467759                  # 0x7232f
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2
.LCPI0_1:
	.long	4294962705              # 0xffffee11
.LCPI0_2:
	.long	4591                    # 0x11ef
.LCPI0_5:
	.long	4294967294              # 0xfffffffe
.LCPI0_6:
	.long	4294967292              # 0xfffffffc
.LCPI0_7:
	.long	1                       # 0x1
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI0_3:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI0_4:
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
.LCPI0_8:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
.LCPI0_9:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.text
	.globl	crypto_kem_keypair
	.p2align	4, 0x90
	.type	crypto_kem_keypair,@function
crypto_kem_keypair:                     # @crypto_kem_keypair
	.cfi_startproc
# %bb.0:
	pushq	%r15
	.cfi_def_cfa_offset 16
	pushq	%r14
	.cfi_def_cfa_offset 24
	pushq	%r13
	.cfi_def_cfa_offset 32
	pushq	%r12
	.cfi_def_cfa_offset 40
	pushq	%rbx
	.cfi_def_cfa_offset 48
	subq	$9952, %rsp             # imm = 0x26E0
	.cfi_def_cfa_offset 10000
	.cfi_offset %rbx, -48
	.cfi_offset %r12, -40
	.cfi_offset %r13, -32
	.cfi_offset %r14, -24
	.cfi_offset %r15, -16
	movq	%rsi, %r14
	movq	%rdi, %r13
	movl	$32, %esi
	callq	randombytes@PLT
	leaq	aes_nonce(%rip), %rdx
	movq	%rsp, %r15
	movl	$3044, %esi             # imm = 0xBE4
	movq	%r15, %rdi
	movq	%r13, %rcx
	callq	crypto_stream_aes256ctr_openssl@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_761xint32_little@PLT
	xorl	%eax, %eax
	vpbroadcastq	.LCPI0_0(%rip), %ymm0 # ymm0 = [467759,467759,467759,467759]
	vpbroadcastd	.LCPI0_1(%rip), %ymm1 # ymm1 = [4294962705,4294962705,4294962705,4294962705,4294962705,4294962705,4294962705,4294962705]
	vpbroadcastd	.LCPI0_2(%rip), %ymm2 # ymm2 = [4591,4591,4591,4591,4591,4591,4591,4591]
	vmovdqa	.LCPI0_4(%rip), %xmm3   # xmm3 = [63241,63241,63241,63241,63241,63241,63241,63241]
	.p2align	4, 0x90
.LBB0_1:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	(%rsp,%rax,4), %ymm4
	vextracti128	$1, %ymm4, %xmm5
	vpmovzxdq	%xmm5, %ymm5    # ymm5 = xmm5[0],zero,xmm5[1],zero,xmm5[2],zero,xmm5[3],zero
	vpmovzxdq	%xmm4, %ymm6    # ymm6 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmuludq	%ymm0, %ymm6, %ymm6
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpsrlq	$31, %ymm5, %ymm5
	vpsrlq	$31, %ymm6, %ymm6
	vpshufd	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vinserti128	$1, %xmm5, %ymm6, %ymm5
	vpmulld	%ymm1, %ymm5, %ymm5
	vpaddd	%ymm4, %ymm5, %ymm4
	vextracti128	$1, %ymm4, %xmm5
	vpmovzxdq	%xmm5, %ymm5    # ymm5 = xmm5[0],zero,xmm5[1],zero,xmm5[2],zero,xmm5[3],zero
	vpmovzxdq	%xmm4, %ymm6    # ymm6 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmuludq	%ymm0, %ymm6, %ymm6
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpsrlq	$31, %ymm5, %ymm5
	vpsrlq	$31, %ymm6, %ymm6
	vpshufd	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vinserti128	$1, %xmm5, %ymm6, %ymm5
	vpmulld	%ymm1, %ymm5, %ymm5
	vpaddd	%ymm1, %ymm4, %ymm4
	vpaddd	%ymm4, %ymm5, %ymm4
	vpsrad	$31, %ymm4, %ymm5
	vpand	%ymm2, %ymm5, %ymm5
	vpaddd	%ymm4, %ymm5, %ymm4
	vpshufb	.LCPI0_3(%rip), %ymm4, %ymm4 # ymm4 = ymm4[0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpaddw	%xmm3, %xmm4, %xmm4
	vmovdqa	%xmm4, 6880(%rsp,%rax,2)
	addq	$8, %rax
	cmpq	$760, %rax              # imm = 0x2F8
	jne	.LBB0_1
# %bb.2:
	movl	3040(%rsp), %eax
	imulq	$467759, %rax, %rcx     # imm = 0x7232F
	shrq	$31, %rcx
	imull	$-4591, %ecx, %ecx      # imm = 0xEE11
	addl	%eax, %ecx
	imulq	$467759, %rcx, %rax     # imm = 0x7232F
	shrq	$31, %rax
	imull	$-4591, %eax, %eax      # imm = 0xEE11
	leal	(%rax,%rcx), %edx
	addl	$-4591, %edx            # imm = 0xEE11
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4591, %edx             # imm = 0x11EF
	leal	(%rdx,%rcx), %eax
	addl	$-6886, %eax            # imm = 0xE51A
	movw	%ax, 8400(%rsp)
	leaq	3056(%rsp), %r15
	movl	$3044, %esi             # imm = 0xBE4
	movq	%r15, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_761xint32_little@PLT
	vbroadcastss	.LCPI0_5(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	3056(%rsp), %ymm0, %ymm1
	vandps	3088(%rsp), %ymm0, %ymm2
	vandps	3120(%rsp), %ymm0, %ymm3
	vandps	3152(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, (%rsp)
	vmovups	%ymm2, 32(%rsp)
	vmovups	%ymm3, 64(%rsp)
	vmovups	%ymm4, 96(%rsp)
	vandps	3184(%rsp), %ymm0, %ymm1
	vandps	3216(%rsp), %ymm0, %ymm2
	vandps	3248(%rsp), %ymm0, %ymm3
	vandps	3280(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 128(%rsp)
	vmovups	%ymm2, 160(%rsp)
	vmovups	%ymm3, 192(%rsp)
	vmovups	%ymm4, 224(%rsp)
	vandps	3312(%rsp), %ymm0, %ymm1
	vandps	3344(%rsp), %ymm0, %ymm2
	vandps	3376(%rsp), %ymm0, %ymm3
	vandps	3408(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 256(%rsp)
	vmovups	%ymm2, 288(%rsp)
	vmovups	%ymm3, 320(%rsp)
	vmovups	%ymm4, 352(%rsp)
	vandps	3440(%rsp), %ymm0, %ymm1
	vandps	3472(%rsp), %ymm0, %ymm2
	vandps	3504(%rsp), %ymm0, %ymm3
	vandps	3536(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 384(%rsp)
	vmovups	%ymm2, 416(%rsp)
	vmovups	%ymm3, 448(%rsp)
	vmovups	%ymm4, 480(%rsp)
	vandps	3568(%rsp), %ymm0, %ymm1
	vandps	3600(%rsp), %ymm0, %ymm2
	vandps	3632(%rsp), %ymm0, %ymm3
	vandps	3664(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 512(%rsp)
	vmovups	%ymm2, 544(%rsp)
	vmovups	%ymm3, 576(%rsp)
	vmovups	%ymm4, 608(%rsp)
	vandps	3696(%rsp), %ymm0, %ymm1
	vandps	3728(%rsp), %ymm0, %ymm2
	vandps	3760(%rsp), %ymm0, %ymm3
	vandps	3792(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 640(%rsp)
	vmovups	%ymm2, 672(%rsp)
	vmovups	%ymm3, 704(%rsp)
	vmovups	%ymm4, 736(%rsp)
	vandps	3824(%rsp), %ymm0, %ymm1
	vandps	3856(%rsp), %ymm0, %ymm2
	vandps	3888(%rsp), %ymm0, %ymm3
	vandps	3920(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 768(%rsp)
	vmovups	%ymm2, 800(%rsp)
	vmovups	%ymm3, 832(%rsp)
	vmovups	%ymm0, 864(%rsp)
	movl	3952(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 896(%rsp)
	movl	3956(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 900(%rsp)
	movl	3960(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 904(%rsp)
	movl	3964(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 908(%rsp)
	movl	3968(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 912(%rsp)
	movl	3972(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 916(%rsp)
	movl	3976(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 920(%rsp)
	movl	3980(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 924(%rsp)
	movl	3984(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 928(%rsp)
	movl	3988(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 932(%rsp)
	movl	3992(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 936(%rsp)
	movl	3996(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 940(%rsp)
	movl	4000(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 944(%rsp)
	movl	4004(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 948(%rsp)
	movl	4008(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 952(%rsp)
	movl	4012(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 956(%rsp)
	movl	4016(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 960(%rsp)
	movl	4020(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 964(%rsp)
	movl	4024(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 968(%rsp)
	movl	4028(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 972(%rsp)
	movl	4032(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 976(%rsp)
	movl	4036(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 980(%rsp)
	movl	4040(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 984(%rsp)
	movl	4044(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 988(%rsp)
	movl	4048(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 992(%rsp)
	movl	4052(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 996(%rsp)
	vpbroadcastd	.LCPI0_6(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	4056(%rsp), %ymm0, %ymm2
	vpand	4088(%rsp), %ymm0, %ymm3
	vpand	4120(%rsp), %ymm0, %ymm4
	vpand	4152(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI0_7(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1000(%rsp)
	vmovdqu	%ymm3, 1032(%rsp)
	vmovdqu	%ymm4, 1064(%rsp)
	vmovdqu	%ymm5, 1096(%rsp)
	vpand	4184(%rsp), %ymm0, %ymm2
	vpand	4216(%rsp), %ymm0, %ymm3
	vpand	4248(%rsp), %ymm0, %ymm4
	vpand	4280(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1128(%rsp)
	vmovdqu	%ymm3, 1160(%rsp)
	vmovdqu	%ymm4, 1192(%rsp)
	vmovdqu	%ymm5, 1224(%rsp)
	vpand	4312(%rsp), %ymm0, %ymm2
	vpand	4344(%rsp), %ymm0, %ymm3
	vpand	4376(%rsp), %ymm0, %ymm4
	vpand	4408(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1256(%rsp)
	vmovdqu	%ymm3, 1288(%rsp)
	vmovdqu	%ymm4, 1320(%rsp)
	vmovdqu	%ymm5, 1352(%rsp)
	vpand	4440(%rsp), %ymm0, %ymm2
	vpand	4472(%rsp), %ymm0, %ymm3
	vpand	4504(%rsp), %ymm0, %ymm4
	vpand	4536(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1384(%rsp)
	vmovdqu	%ymm3, 1416(%rsp)
	vmovdqu	%ymm4, 1448(%rsp)
	vmovdqu	%ymm5, 1480(%rsp)
	vpand	4568(%rsp), %ymm0, %ymm2
	vpand	4600(%rsp), %ymm0, %ymm3
	vpand	4632(%rsp), %ymm0, %ymm4
	vpand	4664(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1512(%rsp)
	vmovdqu	%ymm3, 1544(%rsp)
	vmovdqu	%ymm4, 1576(%rsp)
	vmovdqu	%ymm5, 1608(%rsp)
	vpand	4696(%rsp), %ymm0, %ymm2
	vpand	4728(%rsp), %ymm0, %ymm3
	vpand	4760(%rsp), %ymm0, %ymm4
	vpand	4792(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1640(%rsp)
	vmovdqu	%ymm3, 1672(%rsp)
	vmovdqu	%ymm4, 1704(%rsp)
	vmovdqu	%ymm5, 1736(%rsp)
	vpand	4824(%rsp), %ymm0, %ymm2
	vpand	4856(%rsp), %ymm0, %ymm3
	vpand	4888(%rsp), %ymm0, %ymm4
	vpand	4920(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1768(%rsp)
	vmovdqu	%ymm3, 1800(%rsp)
	vmovdqu	%ymm4, 1832(%rsp)
	vmovdqu	%ymm5, 1864(%rsp)
	vpand	4952(%rsp), %ymm0, %ymm2
	vpand	4984(%rsp), %ymm0, %ymm3
	vpand	5016(%rsp), %ymm0, %ymm4
	vpand	5048(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1896(%rsp)
	vmovdqu	%ymm3, 1928(%rsp)
	vmovdqu	%ymm4, 1960(%rsp)
	vmovdqu	%ymm5, 1992(%rsp)
	vpand	5080(%rsp), %ymm0, %ymm2
	vpand	5112(%rsp), %ymm0, %ymm3
	vpand	5144(%rsp), %ymm0, %ymm4
	vpand	5176(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2024(%rsp)
	vmovdqu	%ymm3, 2056(%rsp)
	vmovdqu	%ymm4, 2088(%rsp)
	vmovdqu	%ymm5, 2120(%rsp)
	vpand	5208(%rsp), %ymm0, %ymm2
	vpand	5240(%rsp), %ymm0, %ymm3
	vpand	5272(%rsp), %ymm0, %ymm4
	vpand	5304(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2152(%rsp)
	vmovdqu	%ymm3, 2184(%rsp)
	vmovdqu	%ymm4, 2216(%rsp)
	vmovdqu	%ymm5, 2248(%rsp)
	vpand	5336(%rsp), %ymm0, %ymm2
	vpand	5368(%rsp), %ymm0, %ymm3
	vpand	5400(%rsp), %ymm0, %ymm4
	vpand	5432(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2280(%rsp)
	vmovdqu	%ymm3, 2312(%rsp)
	vmovdqu	%ymm4, 2344(%rsp)
	vmovdqu	%ymm5, 2376(%rsp)
	vpand	5464(%rsp), %ymm0, %ymm2
	vpand	5496(%rsp), %ymm0, %ymm3
	vpand	5528(%rsp), %ymm0, %ymm4
	vpand	5560(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2408(%rsp)
	vmovdqu	%ymm3, 2440(%rsp)
	vmovdqu	%ymm4, 2472(%rsp)
	vmovdqu	%ymm5, 2504(%rsp)
	vpand	5592(%rsp), %ymm0, %ymm2
	vpand	5624(%rsp), %ymm0, %ymm3
	vpand	5656(%rsp), %ymm0, %ymm4
	vpand	5688(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2536(%rsp)
	vmovdqu	%ymm3, 2568(%rsp)
	vmovdqu	%ymm4, 2600(%rsp)
	vmovdqu	%ymm5, 2632(%rsp)
	vpand	5720(%rsp), %ymm0, %ymm2
	vpand	5752(%rsp), %ymm0, %ymm3
	vpand	5784(%rsp), %ymm0, %ymm4
	vpand	5816(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2664(%rsp)
	vmovdqu	%ymm3, 2696(%rsp)
	vmovdqu	%ymm4, 2728(%rsp)
	vmovdqu	%ymm5, 2760(%rsp)
	vpand	5848(%rsp), %ymm0, %ymm2
	vpand	5880(%rsp), %ymm0, %ymm3
	vpand	5912(%rsp), %ymm0, %ymm4
	vpand	5944(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 2792(%rsp)
	vmovdqu	%ymm3, 2824(%rsp)
	vmovdqu	%ymm4, 2856(%rsp)
	vmovdqu	%ymm0, 2888(%rsp)
	movl	5976(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2920(%rsp)
	movl	5980(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2924(%rsp)
	movl	5984(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2928(%rsp)
	movl	5988(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2932(%rsp)
	movl	5992(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2936(%rsp)
	movl	5996(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2940(%rsp)
	movl	6000(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2944(%rsp)
	movl	6004(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2948(%rsp)
	movl	6008(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2952(%rsp)
	movl	6012(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2956(%rsp)
	movl	6016(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2960(%rsp)
	movl	6020(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2964(%rsp)
	movl	6024(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2968(%rsp)
	movl	6028(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2972(%rsp)
	movl	6032(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2976(%rsp)
	movl	6036(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2980(%rsp)
	movl	6040(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2984(%rsp)
	movl	6044(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2988(%rsp)
	movl	6048(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2992(%rsp)
	movl	6052(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2996(%rsp)
	movl	6056(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3000(%rsp)
	movl	6060(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3004(%rsp)
	movl	6064(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3008(%rsp)
	movl	6068(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3012(%rsp)
	movl	6072(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3016(%rsp)
	movl	6076(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3020(%rsp)
	movl	6080(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3024(%rsp)
	movl	6084(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3028(%rsp)
	movl	6088(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3032(%rsp)
	movl	6092(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3036(%rsp)
	movl	6096(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3040(%rsp)
	movq	%rsp, %rdi
	movl	$761, %esi              # imm = 0x2F9
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	vmovdqa	.LCPI0_3(%rip), %ymm7   # ymm7 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	movl	$24, %eax
	vmovdqa	.LCPI0_8(%rip), %xmm0   # xmm0 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm1, %xmm1, %xmm1
	vmovdqa	.LCPI0_9(%rip), %xmm2   # xmm2 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB0_3:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	-96(%rsp,%rax,4), %ymm3
	vmovdqu	-64(%rsp,%rax,4), %ymm4
	vmovdqu	-32(%rsp,%rax,4), %ymm5
	vmovdqu	(%rsp,%rax,4), %ymm6
	vpshufb	%ymm7, %ymm3, %ymm3
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpshufb	%ymm7, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm7, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm7, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpand	%xmm0, %xmm3, %xmm3
	vpand	%xmm0, %xmm4, %xmm4
	vpand	%xmm0, %xmm5, %xmm5
	vpand	%xmm0, %xmm6, %xmm6
	vpaddb	%xmm1, %xmm3, %xmm3
	vpshufb	%xmm2, %xmm3, %xmm3
	vpaddb	%xmm1, %xmm4, %xmm4
	vpshufb	%xmm2, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 6088(%rsp,%rax)
	vpaddb	%xmm1, %xmm5, %xmm3
	vpshufb	%xmm2, %xmm3, %xmm3
	vpaddb	%xmm1, %xmm6, %xmm4
	vpshufb	%xmm2, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 6104(%rsp,%rax)
	addq	$32, %rax
	cmpq	$760, %rax              # imm = 0x2F8
	jne	.LBB0_3
# %bb.4:
	movb	2944(%rsp), %al
	movb	2948(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6848(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 6849(%rsp)
	movb	2952(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6850(%rsp)
	movb	2956(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6851(%rsp)
	movb	2960(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6852(%rsp)
	movb	2964(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6853(%rsp)
	movb	2968(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6854(%rsp)
	movb	2972(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6855(%rsp)
	movb	2976(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6856(%rsp)
	movb	2980(%rsp), %al
	movb	2984(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6857(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 6858(%rsp)
	movb	2988(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6859(%rsp)
	movb	2992(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6860(%rsp)
	movb	2996(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6861(%rsp)
	movb	3000(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6862(%rsp)
	movb	3004(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6863(%rsp)
	movb	3008(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6864(%rsp)
	movb	3012(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6865(%rsp)
	movb	3016(%rsp), %al
	movb	3020(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6866(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 6867(%rsp)
	movb	3024(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6868(%rsp)
	movb	3028(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6869(%rsp)
	movb	3032(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6870(%rsp)
	movb	3036(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6871(%rsp)
	movb	3040(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6872(%rsp)
	movq	%rsp, %r15
	leaq	6880(%rsp), %rsi
	movq	%r15, %rdi
	vzeroupper
	callq	crypto_encode_761xint16_little@PLT
	xorl	%ebx, %ebx
	leaq	3056(%rsp), %r12
	leaq	6112(%rsp), %rdx
	xorl	%ecx, %ecx
	movq	%r12, %rdi
	movq	%r15, %rsi
	callq	crypto_core_multsntrup761_avx@PLT
	leaq	8416(%rsp), %r15
	movq	%r15, %rdi
	movq	%r12, %rsi
	callq	crypto_decode_761xint16_little@PLT
	leaq	32(%r13), %rdi
	movq	%r15, %rsi
	callq	crypto_encode_761x1531round_ref@PLT
	leaq	191(%r14), %rax
	leaq	1230(%r14), %r15
	leaq	1039(%r13), %rcx
	cmpq	%rcx, %rax
	jae	.LBB0_6
# %bb.5:
	cmpq	%r13, %r15
	ja	.LBB0_7
.LBB0_6:
	vmovups	(%r13), %ymm0
	vmovups	32(%r13), %ymm1
	vmovups	64(%r13), %ymm2
	vmovups	96(%r13), %ymm3
	vmovups	%ymm0, 191(%r14)
	vmovups	%ymm1, 223(%r14)
	vmovups	%ymm2, 255(%r14)
	vmovups	%ymm3, 287(%r14)
	vmovups	128(%r13), %ymm0
	vmovups	160(%r13), %ymm1
	vmovups	192(%r13), %ymm2
	vmovups	224(%r13), %ymm3
	vmovups	%ymm0, 319(%r14)
	vmovups	%ymm1, 351(%r14)
	vmovups	%ymm2, 383(%r14)
	vmovups	%ymm3, 415(%r14)
	vmovups	256(%r13), %ymm0
	vmovups	288(%r13), %ymm1
	vmovups	320(%r13), %ymm2
	vmovups	352(%r13), %ymm3
	vmovups	%ymm0, 447(%r14)
	vmovups	%ymm1, 479(%r14)
	vmovups	%ymm2, 511(%r14)
	vmovups	%ymm3, 543(%r14)
	vmovups	384(%r13), %ymm0
	vmovups	416(%r13), %ymm1
	vmovups	448(%r13), %ymm2
	vmovups	480(%r13), %ymm3
	vmovups	%ymm0, 575(%r14)
	vmovups	%ymm1, 607(%r14)
	vmovups	%ymm2, 639(%r14)
	vmovups	%ymm3, 671(%r14)
	vmovups	512(%r13), %ymm0
	vmovups	544(%r13), %ymm1
	vmovups	576(%r13), %ymm2
	vmovups	608(%r13), %ymm3
	vmovups	%ymm0, 703(%r14)
	vmovups	%ymm1, 735(%r14)
	vmovups	%ymm2, 767(%r14)
	vmovups	%ymm3, 799(%r14)
	vmovups	640(%r13), %ymm0
	vmovups	672(%r13), %ymm1
	vmovups	704(%r13), %ymm2
	vmovups	736(%r13), %ymm3
	vmovups	%ymm0, 831(%r14)
	vmovups	%ymm1, 863(%r14)
	vmovups	%ymm2, 895(%r14)
	vmovups	%ymm3, 927(%r14)
	vmovups	768(%r13), %ymm0
	vmovups	800(%r13), %ymm1
	vmovups	832(%r13), %ymm2
	vmovups	864(%r13), %ymm3
	vmovups	%ymm0, 959(%r14)
	vmovups	%ymm1, 991(%r14)
	vmovups	%ymm2, 1023(%r14)
	vmovups	%ymm3, 1055(%r14)
	vmovdqu	896(%r13), %ymm0
	vmovdqu	928(%r13), %ymm1
	vmovdqu	960(%r13), %ymm2
	vmovdqu	992(%r13), %ymm3
	vmovdqu	%ymm0, 1087(%r14)
	vmovdqu	%ymm1, 1119(%r14)
	vmovdqu	%ymm2, 1151(%r14)
	vmovdqu	%ymm3, 1183(%r14)
	movl	$1024, %ebx             # imm = 0x400
.LBB0_7:
	movq	$-3, %rax
	.p2align	4, 0x90
.LBB0_8:                                # =>This Inner Loop Header: Depth=1
	movzbl	(%r13,%rbx), %ecx
	movb	%cl, 191(%r14,%rbx)
	addq	$1, %rbx
	addq	$1, %rax
	jne	.LBB0_8
	.p2align	4, 0x90
.LBB0_9:                                # =>This Inner Loop Header: Depth=1
	movzbl	(%r13,%rbx), %eax
	movb	%al, 191(%r14,%rbx)
	movzbl	1(%r13,%rbx), %eax
	movb	%al, 192(%r14,%rbx)
	movzbl	2(%r13,%rbx), %eax
	movb	%al, 193(%r14,%rbx)
	movzbl	3(%r13,%rbx), %eax
	movb	%al, 194(%r14,%rbx)
	addq	$4, %rbx
	cmpq	$1039, %rbx             # imm = 0x40F
	jne	.LBB0_9
# %bb.10:
	leaq	190(%r14), %rsi
	movb	$4, 190(%r14)
	leaq	3056(%rsp), %rdi
	movl	$1040, %edx             # imm = 0x410
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	3056(%rsp), %ymm0
	vmovups	%ymm0, 1262(%r14)
	movl	$32, %esi
	movq	%r15, %rdi
	vzeroupper
	callq	randombytes@PLT
	leaq	6112(%rsp), %rsi
	movq	%r14, %rdi
	callq	crypto_encode_761x3_ref@PLT
	xorl	%eax, %eax
	addq	$9952, %rsp             # imm = 0x26E0
	.cfi_def_cfa_offset 48
	popq	%rbx
	.cfi_def_cfa_offset 40
	popq	%r12
	.cfi_def_cfa_offset 32
	popq	%r13
	.cfi_def_cfa_offset 24
	popq	%r14
	.cfi_def_cfa_offset 16
	popq	%r15
	.cfi_def_cfa_offset 8
	retq
.Lfunc_end0:
	.size	crypto_kem_keypair, .Lfunc_end0-crypto_kem_keypair
	.cfi_endproc
                                        # -- End function
	.globl	crypto_kem_enc          # -- Begin function crypto_kem_enc
	.p2align	4, 0x90
	.type	crypto_kem_enc,@function
crypto_kem_enc:                         # @crypto_kem_enc
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$2632, %rsp             # imm = 0xA48
	.cfi_def_cfa_offset 2688
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r13
	movq	%rsi, %r14
	movq	%rdi, %r12
	leaq	385(%rsp), %rdi
	movl	$1039, %edx             # imm = 0x40F
	movq	%r13, %rsi
	callq	memcpy@PLT
	movb	$4, 384(%rsp)
	leaq	32(%rsp), %r15
	leaq	384(%rsp), %rsi
	movl	$1040, %edx             # imm = 0x410
	movq	%r15, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	32(%rsp), %ymm0
	vmovups	%ymm0, (%rsp)
	leaq	96(%rsp), %rbx
	movl	$32, %esi
	movq	%rbx, %rdi
	vzeroupper
	callq	randombytes@PLT
	leaq	128(%rsp), %rbp
	movq	%rbp, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_256x2_avx@PLT
	leaq	1424(%rsp), %rbx
	movq	%rsp, %r8
	movq	%r12, %rdi
	movq	%rbx, %rsi
	movq	%rbp, %rdx
	movq	%r13, %rcx
	callq	Hide
	leaq	1457(%rsp), %rdi
	movl	$1167, %edx             # imm = 0x48F
	movq	%r12, %rsi
	callq	memcpy@PLT
	movb	$1, 1424(%rsp)
	movl	$1200, %edx             # imm = 0x4B0
	movq	%r15, %rdi
	movq	%rbx, %rsi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	32(%rsp), %ymm0
	vmovups	%ymm0, (%r14)
	xorl	%eax, %eax
	addq	$2632, %rsp             # imm = 0xA48
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end1:
	.size	crypto_kem_enc, .Lfunc_end1-crypto_kem_enc
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst8,"aM",@progbits,8
	.p2align	3               # -- Begin function Hide
.LCPI2_0:
	.quad	467759                  # 0x7232f
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2
.LCPI2_1:
	.long	4294962705              # 0xffffee11
.LCPI2_2:
	.long	4591                    # 0x11ef
.LCPI2_5:
	.long	4294967294              # 0xfffffffe
.LCPI2_6:
	.long	4294967292              # 0xfffffffc
.LCPI2_7:
	.long	1                       # 0x1
.LCPI2_10:
	.long	2295                    # 0x8f7
.LCPI2_11:
	.long	57                      # 0x39
.LCPI2_12:
	.long	29235                   # 0x7233
.LCPI2_13:
	.long	67108864                # 0x4000000
.LCPI2_14:
	.long	114                     # 0x72
.LCPI2_15:
	.long	262168                  # 0x40018
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI2_3:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI2_4:
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
	.short	63241                   # 0xf709
.LCPI2_8:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
.LCPI2_9:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.text
	.p2align	4, 0x90
	.type	Hide,@function
Hide:                                   # @Hide
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$14760, %rsp            # imm = 0x39A8
	.cfi_def_cfa_offset 14816
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%r8, (%rsp)             # 8-byte Spill
	movq	%rcx, %r13
	movq	%rdx, %rbx
	movq	%rsi, %r12
	movq	%rdi, 8(%rsp)           # 8-byte Spill
	addq	$1, %r12
	movq	%r12, %rdi
	movq	%rdx, %rsi
	callq	crypto_encode_256x2_avx@PLT
	leaq	32(%r13), %rsi
	leaq	13232(%rsp), %rdi
	callq	crypto_decode_761x1531_avx@PLT
	leaq	aes_nonce(%rip), %rdx
	leaq	208(%rsp), %rbp
	movl	$3044, %esi             # imm = 0xBE4
	movq	%rbp, %rdi
	movq	%r13, %rcx
	callq	crypto_stream_aes256ctr_openssl@PLT
	movq	%rbp, %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_761xint32_little@PLT
	xorl	%eax, %eax
	vpbroadcastq	.LCPI2_0(%rip), %ymm0 # ymm0 = [467759,467759,467759,467759]
	vpbroadcastd	.LCPI2_1(%rip), %ymm6 # ymm6 = [4294962705,4294962705,4294962705,4294962705,4294962705,4294962705,4294962705,4294962705]
	vpbroadcastd	.LCPI2_2(%rip), %ymm1 # ymm1 = [4591,4591,4591,4591,4591,4591,4591,4591]
	vmovdqa	.LCPI2_4(%rip), %xmm2   # xmm2 = [63241,63241,63241,63241,63241,63241,63241,63241]
	.p2align	4, 0x90
.LBB2_1:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	208(%rsp,%rax,4), %ymm3
	vextracti128	$1, %ymm3, %xmm4
	vpmovzxdq	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmovzxdq	%xmm3, %ymm5    # ymm5 = xmm3[0],zero,xmm3[1],zero,xmm3[2],zero,xmm3[3],zero
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpmuludq	%ymm0, %ymm4, %ymm4
	vpsrlq	$31, %ymm4, %ymm4
	vpsrlq	$31, %ymm5, %ymm5
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufd	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vinserti128	$1, %xmm4, %ymm5, %ymm4
	vpmulld	%ymm6, %ymm4, %ymm4
	vpaddd	%ymm3, %ymm4, %ymm3
	vextracti128	$1, %ymm3, %xmm4
	vpmovzxdq	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmovzxdq	%xmm3, %ymm5    # ymm5 = xmm3[0],zero,xmm3[1],zero,xmm3[2],zero,xmm3[3],zero
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpmuludq	%ymm0, %ymm4, %ymm4
	vpsrlq	$31, %ymm4, %ymm4
	vpsrlq	$31, %ymm5, %ymm5
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufd	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vinserti128	$1, %xmm4, %ymm5, %ymm4
	vpmulld	%ymm6, %ymm4, %ymm4
	vpaddd	%ymm6, %ymm3, %ymm3
	vpaddd	%ymm3, %ymm4, %ymm3
	vpsrad	$31, %ymm3, %ymm4
	vpand	%ymm1, %ymm4, %ymm4
	vpaddd	%ymm3, %ymm4, %ymm3
	vpshufb	.LCPI2_3(%rip), %ymm3, %ymm3 # ymm3 = ymm3[0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpaddw	%xmm2, %xmm3, %xmm3
	vmovdqa	%xmm3, 10160(%rsp,%rax,2)
	addq	$8, %rax
	cmpq	$760, %rax              # imm = 0x2F8
	jne	.LBB2_1
# %bb.2:
	vmovdqu	%ymm6, 64(%rsp)         # 32-byte Spill
	movl	3248(%rsp), %eax
	imulq	$467759, %rax, %rcx     # imm = 0x7232F
	shrq	$31, %rcx
	imull	$-4591, %ecx, %ecx      # imm = 0xEE11
	addl	%eax, %ecx
	imulq	$467759, %rcx, %rax     # imm = 0x7232F
	shrq	$31, %rax
	imull	$-4591, %eax, %eax      # imm = 0xEE11
	leal	(%rax,%rcx), %edx
	addl	$-4591, %edx            # imm = 0xEE11
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4591, %edx             # imm = 0x11EF
	leal	(%rdx,%rcx), %eax
	addl	$-6886, %eax            # imm = 0xE51A
	movw	%ax, 11680(%rsp)
	leaq	17(%rsp), %rdi
	movq	%rbx, %rsi
	vzeroupper
	callq	crypto_encode_256x2_avx@PLT
	movb	$5, 16(%rsp)
	leaq	144(%rsp), %rdi
	leaq	16(%rsp), %rsi
	movl	$33, %edx
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	144(%rsp), %ymm0
	vmovups	%ymm0, 112(%rsp)
	leaq	aes_nonce(%rip), %rdx
	leaq	3264(%rsp), %rbp
	leaq	112(%rsp), %rcx
	movl	$3044, %esi             # imm = 0xBE4
	movq	%rbp, %rdi
	vzeroupper
	callq	crypto_stream_aes256ctr_openssl@PLT
	movq	%rbp, %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_761xint32_little@PLT
	vbroadcastss	.LCPI2_5(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	3264(%rsp), %ymm0, %ymm1
	vandps	3296(%rsp), %ymm0, %ymm2
	vandps	3328(%rsp), %ymm0, %ymm3
	vandps	3360(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 208(%rsp)
	vmovups	%ymm2, 240(%rsp)
	vmovups	%ymm3, 272(%rsp)
	vmovups	%ymm4, 304(%rsp)
	vandps	3392(%rsp), %ymm0, %ymm1
	vandps	3424(%rsp), %ymm0, %ymm2
	vandps	3456(%rsp), %ymm0, %ymm3
	vandps	3488(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 336(%rsp)
	vmovups	%ymm2, 368(%rsp)
	vmovups	%ymm3, 400(%rsp)
	vmovups	%ymm4, 432(%rsp)
	vandps	3520(%rsp), %ymm0, %ymm1
	vandps	3552(%rsp), %ymm0, %ymm2
	vandps	3584(%rsp), %ymm0, %ymm3
	vandps	3616(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 464(%rsp)
	vmovups	%ymm2, 496(%rsp)
	vmovups	%ymm3, 528(%rsp)
	vmovups	%ymm4, 560(%rsp)
	vandps	3648(%rsp), %ymm0, %ymm1
	vandps	3680(%rsp), %ymm0, %ymm2
	vandps	3712(%rsp), %ymm0, %ymm3
	vandps	3744(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 592(%rsp)
	vmovups	%ymm2, 624(%rsp)
	vmovups	%ymm3, 656(%rsp)
	vmovups	%ymm4, 688(%rsp)
	vandps	3776(%rsp), %ymm0, %ymm1
	vandps	3808(%rsp), %ymm0, %ymm2
	vandps	3840(%rsp), %ymm0, %ymm3
	vandps	3872(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 720(%rsp)
	vmovups	%ymm2, 752(%rsp)
	vmovups	%ymm3, 784(%rsp)
	vmovups	%ymm4, 816(%rsp)
	vandps	3904(%rsp), %ymm0, %ymm1
	vandps	3936(%rsp), %ymm0, %ymm2
	vandps	3968(%rsp), %ymm0, %ymm3
	vandps	4000(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 848(%rsp)
	vmovups	%ymm2, 880(%rsp)
	vmovups	%ymm3, 912(%rsp)
	vmovups	%ymm4, 944(%rsp)
	vandps	4032(%rsp), %ymm0, %ymm1
	vandps	4064(%rsp), %ymm0, %ymm2
	vandps	4096(%rsp), %ymm0, %ymm3
	vandps	4128(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 976(%rsp)
	vmovups	%ymm2, 1008(%rsp)
	vmovups	%ymm3, 1040(%rsp)
	vmovups	%ymm0, 1072(%rsp)
	movl	4160(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1104(%rsp)
	movl	4164(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1108(%rsp)
	movl	4168(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1112(%rsp)
	movl	4172(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1116(%rsp)
	movl	4176(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1120(%rsp)
	movl	4180(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1124(%rsp)
	movl	4184(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1128(%rsp)
	movl	4188(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1132(%rsp)
	movl	4192(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1136(%rsp)
	movl	4196(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1140(%rsp)
	movl	4200(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1144(%rsp)
	movl	4204(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1148(%rsp)
	movl	4208(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1152(%rsp)
	movl	4212(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1156(%rsp)
	movl	4216(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1160(%rsp)
	movl	4220(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1164(%rsp)
	movl	4224(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1168(%rsp)
	movl	4228(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1172(%rsp)
	movl	4232(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1176(%rsp)
	movl	4236(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1180(%rsp)
	movl	4240(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1184(%rsp)
	movl	4244(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1188(%rsp)
	movl	4248(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1192(%rsp)
	movl	4252(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1196(%rsp)
	movl	4256(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1200(%rsp)
	movl	4260(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1204(%rsp)
	vpbroadcastd	.LCPI2_6(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	4264(%rsp), %ymm0, %ymm2
	vpand	4296(%rsp), %ymm0, %ymm3
	vpand	4328(%rsp), %ymm0, %ymm4
	vpand	4360(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI2_7(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1208(%rsp)
	vmovdqu	%ymm3, 1240(%rsp)
	vmovdqu	%ymm4, 1272(%rsp)
	vmovdqu	%ymm5, 1304(%rsp)
	vpand	4392(%rsp), %ymm0, %ymm2
	vpand	4424(%rsp), %ymm0, %ymm3
	vpand	4456(%rsp), %ymm0, %ymm4
	vpand	4488(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1336(%rsp)
	vmovdqu	%ymm3, 1368(%rsp)
	vmovdqu	%ymm4, 1400(%rsp)
	vmovdqu	%ymm5, 1432(%rsp)
	vpand	4520(%rsp), %ymm0, %ymm2
	vpand	4552(%rsp), %ymm0, %ymm3
	vpand	4584(%rsp), %ymm0, %ymm4
	vpand	4616(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1464(%rsp)
	vmovdqu	%ymm3, 1496(%rsp)
	vmovdqu	%ymm4, 1528(%rsp)
	vmovdqu	%ymm5, 1560(%rsp)
	vpand	4648(%rsp), %ymm0, %ymm2
	vpand	4680(%rsp), %ymm0, %ymm3
	vpand	4712(%rsp), %ymm0, %ymm4
	vpand	4744(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1592(%rsp)
	vmovdqu	%ymm3, 1624(%rsp)
	vmovdqu	%ymm4, 1656(%rsp)
	vmovdqu	%ymm5, 1688(%rsp)
	vpand	4776(%rsp), %ymm0, %ymm2
	vpand	4808(%rsp), %ymm0, %ymm3
	vpand	4840(%rsp), %ymm0, %ymm4
	vpand	4872(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1720(%rsp)
	vmovdqu	%ymm3, 1752(%rsp)
	vmovdqu	%ymm4, 1784(%rsp)
	vmovdqu	%ymm5, 1816(%rsp)
	vpand	4904(%rsp), %ymm0, %ymm2
	vpand	4936(%rsp), %ymm0, %ymm3
	vpand	4968(%rsp), %ymm0, %ymm4
	vpand	5000(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1848(%rsp)
	vmovdqu	%ymm3, 1880(%rsp)
	vmovdqu	%ymm4, 1912(%rsp)
	vmovdqu	%ymm5, 1944(%rsp)
	vpand	5032(%rsp), %ymm0, %ymm2
	vpand	5064(%rsp), %ymm0, %ymm3
	vpand	5096(%rsp), %ymm0, %ymm4
	vpand	5128(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1976(%rsp)
	vmovdqu	%ymm3, 2008(%rsp)
	vmovdqu	%ymm4, 2040(%rsp)
	vmovdqu	%ymm5, 2072(%rsp)
	vpand	5160(%rsp), %ymm0, %ymm2
	vpand	5192(%rsp), %ymm0, %ymm3
	vpand	5224(%rsp), %ymm0, %ymm4
	vpand	5256(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2104(%rsp)
	vmovdqu	%ymm3, 2136(%rsp)
	vmovdqu	%ymm4, 2168(%rsp)
	vmovdqu	%ymm5, 2200(%rsp)
	vpand	5288(%rsp), %ymm0, %ymm2
	vpand	5320(%rsp), %ymm0, %ymm3
	vpand	5352(%rsp), %ymm0, %ymm4
	vpand	5384(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2232(%rsp)
	vmovdqu	%ymm3, 2264(%rsp)
	vmovdqu	%ymm4, 2296(%rsp)
	vmovdqu	%ymm5, 2328(%rsp)
	vpand	5416(%rsp), %ymm0, %ymm2
	vpand	5448(%rsp), %ymm0, %ymm3
	vpand	5480(%rsp), %ymm0, %ymm4
	vpand	5512(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2360(%rsp)
	vmovdqu	%ymm3, 2392(%rsp)
	vmovdqu	%ymm4, 2424(%rsp)
	vmovdqu	%ymm5, 2456(%rsp)
	vpand	5544(%rsp), %ymm0, %ymm2
	vpand	5576(%rsp), %ymm0, %ymm3
	vpand	5608(%rsp), %ymm0, %ymm4
	vpand	5640(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2488(%rsp)
	vmovdqu	%ymm3, 2520(%rsp)
	vmovdqu	%ymm4, 2552(%rsp)
	vmovdqu	%ymm5, 2584(%rsp)
	vpand	5672(%rsp), %ymm0, %ymm2
	vpand	5704(%rsp), %ymm0, %ymm3
	vpand	5736(%rsp), %ymm0, %ymm4
	vpand	5768(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2616(%rsp)
	vmovdqu	%ymm3, 2648(%rsp)
	vmovdqu	%ymm4, 2680(%rsp)
	vmovdqu	%ymm5, 2712(%rsp)
	vpand	5800(%rsp), %ymm0, %ymm2
	vpand	5832(%rsp), %ymm0, %ymm3
	vpand	5864(%rsp), %ymm0, %ymm4
	vpand	5896(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2744(%rsp)
	vmovdqu	%ymm3, 2776(%rsp)
	vmovdqu	%ymm4, 2808(%rsp)
	vmovdqu	%ymm5, 2840(%rsp)
	vpand	5928(%rsp), %ymm0, %ymm2
	vpand	5960(%rsp), %ymm0, %ymm3
	vpand	5992(%rsp), %ymm0, %ymm4
	vpand	6024(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2872(%rsp)
	vmovdqu	%ymm3, 2904(%rsp)
	vmovdqu	%ymm4, 2936(%rsp)
	vmovdqu	%ymm5, 2968(%rsp)
	vpand	6056(%rsp), %ymm0, %ymm2
	vpand	6088(%rsp), %ymm0, %ymm3
	vpand	6120(%rsp), %ymm0, %ymm4
	vpand	6152(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 3000(%rsp)
	vmovdqu	%ymm3, 3032(%rsp)
	vmovdqu	%ymm4, 3064(%rsp)
	vmovdqu	%ymm0, 3096(%rsp)
	movl	6184(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3128(%rsp)
	movl	6188(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3132(%rsp)
	movl	6192(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3136(%rsp)
	movl	6196(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3140(%rsp)
	movl	6200(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3144(%rsp)
	movl	6204(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3148(%rsp)
	movl	6208(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3152(%rsp)
	movl	6212(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3156(%rsp)
	movl	6216(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3160(%rsp)
	movl	6220(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3164(%rsp)
	movl	6224(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3168(%rsp)
	movl	6228(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3172(%rsp)
	movl	6232(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3176(%rsp)
	movl	6236(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3180(%rsp)
	movl	6240(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3184(%rsp)
	movl	6244(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3188(%rsp)
	movl	6248(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3192(%rsp)
	movl	6252(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3196(%rsp)
	movl	6256(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3200(%rsp)
	movl	6260(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3204(%rsp)
	movl	6264(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3208(%rsp)
	movl	6268(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3212(%rsp)
	movl	6272(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3216(%rsp)
	movl	6276(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3220(%rsp)
	movl	6280(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3224(%rsp)
	movl	6284(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3228(%rsp)
	movl	6288(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3232(%rsp)
	movl	6292(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3236(%rsp)
	movl	6296(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3240(%rsp)
	movl	6300(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3244(%rsp)
	movl	6304(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3248(%rsp)
	leaq	208(%rsp), %rdi
	movl	$761, %esi              # imm = 0x2F9
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	vmovdqa	.LCPI2_3(%rip), %ymm6   # ymm6 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	movl	$24, %eax
	vmovdqa	.LCPI2_8(%rip), %xmm0   # xmm0 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm1, %xmm1, %xmm1
	vmovdqa	.LCPI2_9(%rip), %xmm7   # xmm7 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB2_3:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	112(%rsp,%rax,4), %ymm2
	vmovdqu	144(%rsp,%rax,4), %ymm3
	vmovdqu	176(%rsp,%rax,4), %ymm4
	vmovdqu	208(%rsp,%rax,4), %ymm5
	vpshufb	%ymm6, %ymm2, %ymm2
	vpermq	$232, %ymm2, %ymm2      # ymm2 = ymm2[0,2,2,3]
	vpshufb	%ymm6, %ymm3, %ymm3
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpshufb	%ymm6, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm6, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpand	%xmm0, %xmm2, %xmm2
	vpand	%xmm0, %xmm3, %xmm3
	vpand	%xmm0, %xmm4, %xmm4
	vpand	%xmm0, %xmm5, %xmm5
	vpaddb	%xmm1, %xmm2, %xmm2
	vpshufb	%xmm7, %xmm2, %xmm2
	vpaddb	%xmm1, %xmm3, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpunpcklqdq	%xmm3, %xmm2, %xmm2 # xmm2 = xmm2[0],xmm3[0]
	vmovdqa	%xmm2, 6296(%rsp,%rax)
	vpaddb	%xmm1, %xmm4, %xmm2
	vpshufb	%xmm7, %xmm2, %xmm2
	vpaddb	%xmm1, %xmm5, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpunpcklqdq	%xmm3, %xmm2, %xmm2 # xmm2 = xmm2[0],xmm3[0]
	vmovdqa	%xmm2, 6312(%rsp,%rax)
	addq	$32, %rax
	cmpq	$760, %rax              # imm = 0x2F8
	jne	.LBB2_3
# %bb.4:
	movb	3152(%rsp), %al
	movb	3156(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7056(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 7057(%rsp)
	movb	3160(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7058(%rsp)
	movb	3164(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7059(%rsp)
	movb	3168(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7060(%rsp)
	movb	3172(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7061(%rsp)
	movb	3176(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7062(%rsp)
	movb	3180(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7063(%rsp)
	movb	3184(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7064(%rsp)
	movb	3188(%rsp), %al
	movb	3192(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7065(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 7066(%rsp)
	movb	3196(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7067(%rsp)
	movb	3200(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7068(%rsp)
	movb	3204(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7069(%rsp)
	movb	3208(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7070(%rsp)
	movb	3212(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7071(%rsp)
	movb	3216(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7072(%rsp)
	movb	3220(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7073(%rsp)
	movb	3224(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7074(%rsp)
	movb	3228(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7075(%rsp)
	movb	3232(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7076(%rsp)
	movb	3236(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7077(%rsp)
	movb	3240(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7078(%rsp)
	movb	3244(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7079(%rsp)
	movb	3248(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 7080(%rsp)
	leaq	7088(%rsp), %r13
	leaq	10160(%rsp), %rsi
	movq	%r13, %rdi
	vzeroupper
	callq	crypto_encode_761xint16_little@PLT
	xorl	%r15d, %r15d
	leaq	208(%rsp), %rbp
	leaq	6320(%rsp), %r14
	xorl	%ecx, %ecx
	movq	%rbp, %rdi
	movq	%r13, %rsi
	movq	%r14, %rdx
	callq	crypto_core_multsntrup761_avx@PLT
	leaq	11696(%rsp), %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_761xint16_little@PLT
	leaq	13232(%rsp), %rsi
	movq	%r13, %rdi
	callq	crypto_encode_761xint16_little@PLT
	xorl	%ecx, %ecx
	movq	%rbp, %rdi
	movq	%r13, %rsi
	movq	%r14, %rdx
	callq	crypto_core_multsntrup761_avx@PLT
	leaq	8624(%rsp), %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_761xint16_little@PLT
	vmovdqa	.LCPI2_9(%rip), %xmm12  # xmm12 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	vmovdqa	.LCPI2_3(%rip), %ymm11  # ymm11 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vpbroadcastd	.LCPI2_10(%rip), %ymm0 # ymm0 = [2295,2295,2295,2295,2295,2295,2295,2295]
	vpbroadcastd	.LCPI2_11(%rip), %ymm1 # ymm1 = [57,57,57,57,57,57,57,57]
	vpbroadcastd	.LCPI2_12(%rip), %ymm2 # ymm2 = [29235,29235,29235,29235,29235,29235,29235,29235]
	vpbroadcastd	.LCPI2_13(%rip), %ymm3 # ymm3 = [67108864,67108864,67108864,67108864,67108864,67108864,67108864,67108864]
	vpbroadcastd	.LCPI2_14(%rip), %ymm4 # ymm4 = [114,114,114,114,114,114,114,114]
	vpbroadcastd	.LCPI2_15(%rip), %ymm5 # ymm5 = [262168,262168,262168,262168,262168,262168,262168,262168]
	vmovdqu	64(%rsp), %ymm10        # 32-byte Reload
	.p2align	4, 0x90
.LBB2_5:                                # =>This Inner Loop Header: Depth=1
	vpmovsxwd	8624(%rsp,%r15,2), %ymm6
	vpmovsxwd	8640(%rsp,%r15,2), %ymm7
	vpmovsxbd	8(%rbx,%r15), %ymm8
	vpmovsxbd	(%rbx,%r15), %ymm9
	vpmulld	%ymm0, %ymm9, %ymm9
	vpaddd	%ymm6, %ymm9, %ymm6
	vpmulld	%ymm0, %ymm8, %ymm8
	vpaddd	%ymm7, %ymm8, %ymm7
	vpmulld	%ymm1, %ymm6, %ymm8
	vpmulld	%ymm1, %ymm7, %ymm9
	vpsrad	$18, %ymm9, %ymm9
	vpsrad	$18, %ymm8, %ymm8
	vpmulld	%ymm10, %ymm8, %ymm8
	vpmulld	%ymm10, %ymm9, %ymm9
	vpaddd	%ymm7, %ymm9, %ymm7
	vpaddd	%ymm6, %ymm8, %ymm6
	vpmulld	%ymm2, %ymm6, %ymm8
	vpmulld	%ymm2, %ymm7, %ymm9
	vpaddd	%ymm3, %ymm9, %ymm9
	vpaddd	%ymm3, %ymm8, %ymm8
	vpsrad	$27, %ymm8, %ymm8
	vpsrad	$27, %ymm9, %ymm9
	vpmulld	%ymm10, %ymm9, %ymm9
	vpmulld	%ymm10, %ymm8, %ymm8
	vpaddd	%ymm6, %ymm8, %ymm6
	vpaddd	%ymm7, %ymm9, %ymm7
	vpslld	$16, %ymm7, %ymm7
	vpsrad	$16, %ymm7, %ymm7
	vpslld	$16, %ymm6, %ymm6
	vpsrad	$16, %ymm6, %ymm6
	vpmulld	%ymm4, %ymm6, %ymm6
	vpmulld	%ymm4, %ymm7, %ymm7
	vpaddd	%ymm5, %ymm7, %ymm7
	vpaddd	%ymm5, %ymm6, %ymm6
	vpsrld	$15, %ymm6, %ymm6
	vpsrld	$15, %ymm7, %ymm7
	vpshufb	%ymm11, %ymm7, %ymm7
	vpermq	$232, %ymm7, %ymm7      # ymm7 = ymm7[0,2,2,3]
	vpshufb	%xmm12, %xmm7, %xmm7
	vpshufb	%ymm11, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufb	%xmm12, %xmm6, %xmm6
	vpunpcklqdq	%xmm7, %xmm6, %xmm6 # xmm6 = xmm6[0],xmm7[0]
	vmovdqa	%xmm6, 208(%rsp,%r15)
	addq	$16, %r15
	cmpq	$256, %r15              # imm = 0x100
	jne	.LBB2_5
# %bb.6:
	leaq	11696(%rsp), %rsi
	movq	8(%rsp), %rbx           # 8-byte Reload
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_encode_761x1531round_ref@PLT
	leaq	1007(%rbx), %rdi
	leaq	208(%rsp), %rsi
	callq	crypto_encode_256x16_ref@PLT
	vmovups	(%r12), %ymm0
	vmovups	%ymm0, 7089(%rsp)
	movq	(%rsp), %rax            # 8-byte Reload
	vmovups	(%rax), %ymm0
	vmovups	%ymm0, 7121(%rsp)
	movb	$2, 7088(%rsp)
	leaq	144(%rsp), %rdi
	leaq	7088(%rsp), %rsi
	movl	$65, %edx
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	144(%rsp), %ymm0
	vmovups	%ymm0, 1135(%rbx)
	addq	$14760, %rsp            # imm = 0x39A8
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end2:
	.size	Hide, .Lfunc_end2-Hide
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_dec
.LCPI3_0:
	.long	287                     # 0x11f
.LCPI3_1:
	.long	4294965289              # 0xfffff829
.LCPI3_2:
	.long	57                      # 0x39
.LCPI3_3:
	.long	4294962705              # 0xffffee11
.LCPI3_4:
	.long	29235                   # 0x7233
.LCPI3_5:
	.long	67108864                # 0x4000000
.LCPI3_6:
	.long	1001                    # 0x3e9
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI3_7:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.text
	.globl	crypto_kem_dec
	.p2align	4, 0x90
	.type	crypto_kem_dec,@function
crypto_kem_dec:                         # @crypto_kem_dec
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$7496, %rsp             # imm = 0x1D48
	.cfi_def_cfa_offset 7552
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r15
	movq	%rsi, %rbx
	movq	%rdi, 8(%rsp)           # 8-byte Spill
	leaq	5200(%rsp), %r12
	movq	%r12, %rdi
	movq	%rdx, %rsi
	callq	crypto_decode_761x3_ref@PLT
	leaq	5968(%rsp), %r13
	movq	%r13, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_761x1531_avx@PLT
	leaq	1007(%rbx), %rsi
	leaq	1616(%rsp), %rdi
	callq	crypto_decode_256x16_ref@PLT
	leaq	80(%rsp), %r14
	movq	%r14, %rdi
	movq	%r13, %rsi
	callq	crypto_encode_761xint16_little@PLT
	xorl	%ebp, %ebp
	leaq	2128(%rsp), %r13
	xorl	%ecx, %ecx
	movq	%r13, %rdi
	movq	%r14, %rsi
	movq	%r12, %rdx
	callq	crypto_core_multsntrup761_avx@PLT
	leaq	3664(%rsp), %rdi
	movq	%r13, %rsi
	callq	crypto_decode_761xint16_little@PLT
	vpbroadcastd	.LCPI3_0(%rip), %ymm0 # ymm0 = [287,287,287,287,287,287,287,287]
	vpbroadcastd	.LCPI3_1(%rip), %ymm1 # ymm1 = [4294965289,4294965289,4294965289,4294965289,4294965289,4294965289,4294965289,4294965289]
	vpbroadcastd	.LCPI3_2(%rip), %ymm2 # ymm2 = [57,57,57,57,57,57,57,57]
	vpbroadcastd	.LCPI3_3(%rip), %ymm3 # ymm3 = [4294962705,4294962705,4294962705,4294962705,4294962705,4294962705,4294962705,4294962705]
	vpbroadcastd	.LCPI3_4(%rip), %ymm4 # ymm4 = [29235,29235,29235,29235,29235,29235,29235,29235]
	vpbroadcastd	.LCPI3_5(%rip), %ymm5 # ymm5 = [67108864,67108864,67108864,67108864,67108864,67108864,67108864,67108864]
	vpbroadcastd	.LCPI3_6(%rip), %ymm6 # ymm6 = [1001,1001,1001,1001,1001,1001,1001,1001]
	vmovdqa	.LCPI3_7(%rip), %ymm12  # ymm12 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	.p2align	4, 0x90
.LBB3_1:                                # =>This Inner Loop Header: Depth=1
	vpmovsxbd	1616(%rsp,%rbp), %ymm8
	vpmovsxbd	1624(%rsp,%rbp), %ymm9
	vpmulld	%ymm0, %ymm9, %ymm9
	vpmulld	%ymm0, %ymm8, %ymm8
	vpaddd	%ymm1, %ymm8, %ymm8
	vpaddd	%ymm1, %ymm9, %ymm9
	vpmulld	%ymm2, %ymm9, %ymm10
	vpmulld	%ymm2, %ymm8, %ymm11
	vpsrad	$18, %ymm11, %ymm11
	vpsrad	$18, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm11, %ymm11
	vpaddd	%ymm8, %ymm11, %ymm8
	vpaddd	%ymm9, %ymm10, %ymm9
	vpmulld	%ymm4, %ymm9, %ymm10
	vpmulld	%ymm4, %ymm8, %ymm11
	vpaddd	%ymm5, %ymm11, %ymm11
	vpaddd	%ymm5, %ymm10, %ymm10
	vpsrad	$27, %ymm10, %ymm10
	vpsrad	$27, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm10, %ymm10
	vpaddd	%ymm9, %ymm10, %ymm9
	vpaddd	%ymm8, %ymm11, %ymm8
	vpslld	$16, %ymm8, %ymm8
	vpsrad	$16, %ymm8, %ymm8
	vpslld	$16, %ymm9, %ymm9
	vpmovsxwd	3664(%rsp,%rbp,2), %ymm10
	vpsrad	$16, %ymm9, %ymm9
	vpsubd	%ymm10, %ymm8, %ymm8
	vpmovsxwd	3680(%rsp,%rbp,2), %ymm10
	vpsubd	%ymm10, %ymm9, %ymm9
	vpaddd	%ymm6, %ymm8, %ymm8
	vpaddd	%ymm6, %ymm9, %ymm9
	vpmulld	%ymm2, %ymm9, %ymm10
	vpmulld	%ymm2, %ymm8, %ymm11
	vpsrad	$18, %ymm11, %ymm11
	vpsrad	$18, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm11, %ymm11
	vpaddd	%ymm8, %ymm11, %ymm8
	vpaddd	%ymm9, %ymm10, %ymm9
	vpmulld	%ymm4, %ymm9, %ymm10
	vpmulld	%ymm4, %ymm8, %ymm11
	vpaddd	%ymm5, %ymm11, %ymm11
	vpaddd	%ymm5, %ymm10, %ymm10
	vpsrad	$27, %ymm10, %ymm10
	vpsrad	$27, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm10, %ymm10
	vpaddd	%ymm9, %ymm10, %ymm9
	vpaddd	%ymm8, %ymm11, %ymm8
	vpshufb	%ymm12, %ymm8, %ymm8
	vpermq	$232, %ymm8, %ymm8      # ymm8 = ymm8[0,2,2,3]
	vpshufb	%ymm12, %ymm9, %ymm9
	vpermq	$232, %ymm9, %ymm9      # ymm9 = ymm9[0,2,2,3]
	vinserti128	$1, %xmm9, %ymm8, %ymm8
	vpsrlw	$15, %ymm8, %ymm8
	vextracti128	$1, %ymm8, %xmm7
	vpackuswb	%xmm7, %xmm8, %xmm7
	vmovdqa	%xmm7, 1872(%rsp,%rbp)
	addq	$16, %rbp
	cmpq	$256, %rbp              # imm = 0x100
	jne	.LBB3_1
# %bb.2:
	leaq	191(%r15), %rcx
	leaq	1262(%r15), %r8
	leaq	80(%rsp), %rdi
	leaq	2128(%rsp), %rsi
	leaq	1872(%rsp), %rdx
	vzeroupper
	callq	Hide
	vpxor	%xmm0, %xmm0, %xmm0
	movl	$24, %eax
	vpxor	%xmm1, %xmm1, %xmm1
	vpxor	%xmm2, %xmm2, %xmm2
	vpxor	%xmm3, %xmm3, %xmm3
	.p2align	4, 0x90
.LBB3_3:                                # =>This Inner Loop Header: Depth=1
	vpmovzxbw	-24(%rbx,%rax), %xmm4 # xmm4 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-16(%rbx,%rax), %xmm5 # xmm5 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-8(%rbx,%rax), %xmm6 # xmm6 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	(%rbx,%rax), %xmm8 # xmm8 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	56(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm4, %xmm7, %xmm4
	vpackuswb	%xmm0, %xmm4, %xmm4
	vpmovzxbw	64(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm5, %xmm7, %xmm5
	vpackuswb	%xmm0, %xmm5, %xmm5
	vpmovzxbw	72(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm6, %xmm7, %xmm6
	vpackuswb	%xmm0, %xmm6, %xmm6
	vpmovzxbw	80(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm8, %xmm7, %xmm7
	vpackuswb	%xmm0, %xmm7, %xmm7
	vpmovzxbd	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,zero,zero,xmm4[1],zero,zero,zero,xmm4[2],zero,zero,zero,xmm4[3],zero,zero,zero,xmm4[4],zero,zero,zero,xmm4[5],zero,zero,zero,xmm4[6],zero,zero,zero,xmm4[7],zero,zero,zero
	vpor	%ymm4, %ymm0, %ymm0
	vpmovzxbd	%xmm5, %ymm4    # ymm4 = xmm5[0],zero,zero,zero,xmm5[1],zero,zero,zero,xmm5[2],zero,zero,zero,xmm5[3],zero,zero,zero,xmm5[4],zero,zero,zero,xmm5[5],zero,zero,zero,xmm5[6],zero,zero,zero,xmm5[7],zero,zero,zero
	vpor	%ymm4, %ymm1, %ymm1
	vpmovzxbd	%xmm6, %ymm4    # ymm4 = xmm6[0],zero,zero,zero,xmm6[1],zero,zero,zero,xmm6[2],zero,zero,zero,xmm6[3],zero,zero,zero,xmm6[4],zero,zero,zero,xmm6[5],zero,zero,zero,xmm6[6],zero,zero,zero,xmm6[7],zero,zero,zero
	vpor	%ymm4, %ymm2, %ymm2
	vpmovzxbd	%xmm7, %ymm4    # ymm4 = xmm7[0],zero,zero,zero,xmm7[1],zero,zero,zero,xmm7[2],zero,zero,zero,xmm7[3],zero,zero,zero,xmm7[4],zero,zero,zero,xmm7[5],zero,zero,zero,xmm7[6],zero,zero,zero,xmm7[7],zero,zero,zero
	vpor	%ymm4, %ymm3, %ymm3
	addq	$32, %rax
	cmpq	$1176, %rax             # imm = 0x498
	jne	.LBB3_3
# %bb.4:
	vpor	%ymm0, %ymm1, %ymm0
	vpor	%ymm0, %ymm2, %ymm0
	vpor	%ymm0, %ymm3, %ymm0
	vextracti128	$1, %ymm0, %xmm1
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$78, %xmm0, %xmm1       # xmm1 = xmm0[2,3,0,1]
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$229, %xmm0, %xmm1      # xmm1 = xmm0[1,1,2,3]
	vpor	%ymm1, %ymm0, %ymm0
	movb	1232(%rsp), %al
	movb	1233(%rsp), %cl
	xorb	1152(%rbx), %al
	xorb	1153(%rbx), %cl
	movzbl	%al, %eax
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	1234(%rsp), %al
	xorb	1154(%rbx), %al
	movzbl	%al, %eax
	orl	%ecx, %eax
	movb	1235(%rsp), %cl
	xorb	1155(%rbx), %cl
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	1236(%rsp), %al
	xorb	1156(%rbx), %al
	movzbl	%al, %eax
	movb	1237(%rsp), %dl
	xorb	1157(%rbx), %dl
	orl	%ecx, %eax
	movzbl	%dl, %ecx
	orl	%eax, %ecx
	movb	1238(%rsp), %al
	xorb	1158(%rbx), %al
	movzbl	%al, %eax
	orl	%ecx, %eax
	movb	1239(%rsp), %cl
	xorb	1159(%rbx), %cl
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	1240(%rsp), %al
	xorb	1160(%rbx), %al
	movzbl	%al, %eax
	movb	1241(%rsp), %dl
	xorb	1161(%rbx), %dl
	orl	%ecx, %eax
	movzbl	%dl, %ecx
	orl	%eax, %ecx
	movb	1242(%rsp), %al
	xorb	1162(%rbx), %al
	movzbl	%al, %eax
	orl	%ecx, %eax
	movb	1243(%rsp), %cl
	xorb	1163(%rbx), %cl
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	1244(%rsp), %al
	xorb	1164(%rbx), %al
	vmovd	%xmm0, %edx
	movzbl	%al, %eax
	orl	%ecx, %eax
	movb	1245(%rsp), %cl
	xorb	1165(%rbx), %cl
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	1246(%rsp), %al
	xorb	1166(%rbx), %al
	movzbl	%al, %ebp
	orl	%ecx, %ebp
	orl	%edx, %ebp
	addl	$-1, %ebp
	shrl	$8, %ebp
	andb	$1, %bpl
	movl	%ebp, %eax
	addb	$-1, %al
	vmovdqu	2129(%rsp), %xmm0
	vmovd	%eax, %xmm1
	vpbroadcastb	%xmm1, %xmm1
	vpblendvb	%xmm1, 1230(%r15), %xmm0, %xmm0
	vmovdqu	%xmm0, 2129(%rsp)
	vmovdqu	2145(%rsp), %xmm0
	vpblendvb	%xmm1, 1246(%r15), %xmm0, %xmm0
	vmovdqu	%xmm0, 2145(%rsp)
	leaq	2161(%rsp), %rdi
	movl	$1167, %edx             # imm = 0x48F
	movq	%rbx, %rsi
	vzeroupper
	callq	memcpy@PLT
	movb	%bpl, 2128(%rsp)
	leaq	16(%rsp), %rdi
	leaq	2128(%rsp), %rsi
	movl	$1200, %edx             # imm = 0x4B0
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	16(%rsp), %ymm0
	movq	8(%rsp), %rax           # 8-byte Reload
	vmovups	%ymm0, (%rax)
	xorl	%eax, %eax
	addq	$7496, %rsp             # imm = 0x1D48
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end3:
	.size	crypto_kem_dec, .Lfunc_end3-crypto_kem_dec
	.cfi_endproc
                                        # -- End function
	.type	aes_nonce,@object       # @aes_nonce
	.section	.rodata,"a",@progbits
	.p2align	4
aes_nonce:
	.zero	16
	.size	aes_nonce, 16


	.ident	"clang version 7.0.1-8 (tags/RELEASE_701/final)"
	.section	".note.GNU-stack","",@progbits
